unit Unitconf;

interface

uses FileCtrl,
     SysUtils,
     Unitglob;

Procedure ReadConfiguration;
Procedure WriteConfiguration;
Procedure FindStartingPath;
Procedure PrepareTree;

implementation



Procedure ReadConfiguration;
Begin
  ConfFileOkay:=True;
  AssignFile(ConfFile,StartPath+ConfFileName);
  Try
    Reset(ConfFile);
    Try
      Readln(ConfFile,ComNr);
      Readln(ConfFile,ComSpeed);
      Finally
        CloseFile(ConfFile)
      End
  Except
      ConfFileOkay:=False
  End;
  If Not(     ((ComNr=1) Or (ComNr=2) Or (ComNr=3) Or (ComNr=4))
          And ((ComSpeed=38400) Or (ComSpeed=57600) Or (ComSpeed=115200))
        )
     Then
       ConfFileOkay:=False
End;

Procedure WriteConfiguration;
Begin
  AssignFile(ConfFile,StartPath+ConfFileName);
  Rewrite(ConfFile);
  Writeln(ConfFile,ComNr);
  Writeln(ConfFile,ComSpeed);
  CloseFile(ConfFile)
End;

Procedure FindStartingPath;
Begin
  StartPathPtr:=Pos(ProgFileName,ParamStr(0));
  StartPath:=Copy(ParamStr(0),1,StartPathPtr-1)
End;


Procedure PrepareTree;
Begin
  If Not(DirectoryExists(StartPath+PathArchiveFaxes)) Then
    ForceDirectories(StartPath+PathArchiveFaxes);
  If Not(FileExists(StartPath+IDFaxFileName)) Then
    Begin
       AssignFile(IDFaxFile,StartPath+IDFaxFileName);
       Rewrite(IDFaxFile);
       CloseFile(IDFaxFile)
    End
End;

end.
