unit Unitexpo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  Unitglob,
  Unitexfi,
  Unitextr,
  AdFaxCvt;

type
  TFormExport = class(TForm)
    GroupBoxExportFormat: TGroupBox;
    GroupBoxStartExport: TGroupBox;
    SpeedButtonExportTo1File: TSpeedButton;
    SpeedButtonExportToNFiles: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    GroupBoxFileNames: TGroupBox;
    RadioButtonManually: TRadioButton;
    RadioButtonAutomatic: TRadioButton;
    BevelFileNamesManually: TBevel;
    BevelFileNamesAutomatic: TBevel;
    LabelManually1: TLabel;
    LabelManually2: TLabel;
    LabelAutomatic1: TLabel;
    LabelAutomatic2: TLabel;
    LabelAutomatic4: TLabel;
    LabelAutomatic33: TLabel;
    BitBtnExportQuit: TBitBtn;
    LabelAutomatic5: TLabel;
    LabelFileTypeTo1F3: TLabel;
    LabelFileTypeToNF1: TLabel;
    LabelFileTypeToNF2: TLabel;
    LabelFileTypeToNF3: TLabel;
    LabelBreak: TLabel;
    SaveDialogExport: TSaveDialog;
    ApdFaxUnpacker: TApdFaxUnpacker;
    GroupBoxExportZoom: TGroupBox;
    BevelExportZoomX: TBevel;
    BevelExportZoomY: TBevel;
    LabelExportZoomX: TLabel;
    LabelExportZoomY: TLabel;
    ScrollBarExportZoomX: TScrollBar;
    ScrollBarExportZoomY: TScrollBar;
    LabelExportZoomXAct: TLabel;
    LabelExportZoomYAct: TLabel;
    RadioButtonExportToBMP: TRadioButton;
    RadioButtonExportToPCX: TRadioButton;
    RadioButtonExportToTIFF: TRadioButton;
    procedure BitBtnExportQuitClick(Sender: TObject);
    procedure SpeedButtonExportTo1FileClick(Sender: TObject);
    procedure SpeedButtonExportToNFilesClick(Sender: TObject);
    procedure ApdFaxUnpackerStatus(Sender: TObject; FName: String;
      PageNum: Integer; BytesUnpacked, BytesToUnpack: Longint);
    procedure ScrollBarExportZoomXChange(Sender: TObject);
    procedure ScrollBarExportZoomYChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormExport: TFormExport;

Procedure ExportFaxes;
Procedure AutomaticExport;
Procedure ExportTo1F;
Procedure ExportToNF;
Procedure ExportThisFaxPage(FaxFileName  : String;
                            Var FileNr   : LongInt;
                            ExpFilePren  : String;
                            PageNr       : LongInt;
                            UnpackType   : Char;
                            Var Status   : Boolean);
Procedure ExportThisFaxTotal(FaxFileName : String;
                             Var FileNr  : LongInt;
                             ExpFilePren : String;
                             UnpackType  : Char;
                             Var Status  : Boolean);
Procedure CheckFileName(Var ExportFile : String;
                        Var ExportNr   : LongInt;
                        Var CheckName  : Integer;
                            Extension  : String);
Procedure ManuallyExport;
Procedure ExportTo1FManually;
Procedure ExportToNFManually;
Procedure EraseUpToBackSlash(Var S : String);
Procedure PresetExportParameters;
Procedure SetExportZoomDisp;
Procedure SetExportZoomWork;

implementation

{$R *.DFM}

Procedure ExportFaxes;
Begin
  Repeat
    RestartExport:=False;
    FormExport.ShowModal;
    If (MyResExportFaxes<>MyResExportFaxesQuit) Then
      Begin
        If FormExport.RadioButtonAutomatic.Checked Then
          AutomaticExport;
        If FormExport.RadioButtonManually.Checked Then
          ManuallyExport
      End
  Until Not(RestartExport)
End;

Procedure AutomaticExport;
Begin

  (* Select *)
  (* ------ *)

  If FormExport.RadioButtonExportToBMP.Checked Then
    Repeat
      FormExport.SaveDialogExport.Title:='Name der 1.Datei fr Format BMP';
      FormExport.SaveDialogExport.Filter:='Dateiname fr BMP|FAX*.BMP';
      If NewExportNameBMP Then
        Begin
          NewExportNameBMP:=False;
          FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFile+'.'+
                                                ExtensionBMP
        End;
      If Not(FormExport.SaveDialogExport.Execute) Then
        Begin
          RestartExport:=True;
          Exit
        End;
      ExportFileForBMP:=FormExport.SaveDialogExport.FileName;
      CheckFileName(ExportFileForBMP,ExportFileNrBMP,FileNameOK,'BMP');
      If (FileNameOK<>0) Then
        ExportFileError
    Until (FileNameOK=0);
  (* DCX-EXPORT
  If FormExport.RadioButtonExportToDCX.Checked Then
    Repeat
      FormExport.SaveDialogExport.Title:='Name der 1.Datei fr Format DCX';
      FormExport.SaveDialogExport.Filter:='Dateiname fr DCX|FAX*.DCX';
      If NewExportNameDCX Then
        Begin
          NewExportNameDCX:=False;
          FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFile+'.'+
                                                ExtensionDCX
        End;
      If Not(FormExport.SaveDialogExport.Execute) Then
        Begin
          RestartExport:=True;
          Exit
        End;
      ExportFileForDCX:=FormExport.SaveDialogExport.FileName;
      CheckFileName(ExportFileForDCX,ExportFileNrDCX,FileNameOK,'DCX');
      If (FileNameOK<>0) Then
        ExportFileError
    Until (FileNameOK=0);
  *)
  If FormExport.RadioButtonExportToPCX.Checked Then
    Repeat
      FormExport.SaveDialogExport.Title:='Name der 1.Datei fr Format PCX';
      FormExport.SaveDialogExport.Filter:='Dateiname fr PCX|FAX*.PCX';
      If NewExportNamePCX Then
        Begin
          NewExportNamePCX:=False;
          FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFile+'.'+
                                                ExtensionPCX
        End;
      If Not(FormExport.SaveDialogExport.Execute) Then
        Begin
          RestartExport:=True;
          Exit
        End;
      ExportFileForPCX:=FormExport.SaveDialogExport.FileName;
      CheckFileName(ExportFileForPCX,ExportFileNrPCX,FileNameOK,'PCX');
      If (FileNameOK<>0) Then
        ExportFileError
    Until (FileNameOK=0);
  If FormExport.RadioButtonExportToTIFF.Checked Then
    Repeat
      FormExport.SaveDialogExport.Title:='Name der 1.Datei fr Format TIFF';
      FormExport.SaveDialogExport.Filter:='Dateiname fr TIFF|FAX*.TIF';
      If NewExportNameTIFF Then
        Begin
          NewExportNameTIFF:=False;
          FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFile+'.'+
                                                ExtensionTIFF
        End;
      If Not(FormExport.SaveDialogExport.Execute) Then
        Begin
          RestartExport:=True;
          Exit
        End;
      ExportFileForTIFF:=FormExport.SaveDialogExport.FileName;
      CheckFileName(ExportFileForTIFF,ExportFileNrTIFF,FileNameOK,'TIF');
      If (FileNameOK<>0) Then
        ExportFileError
    Until (FileNameOK=0);

    (* Convert *)
    (* ------- *)

  If (MyResExportFaxes=MyResExportFaxesTo1F) Then
    ExportTo1F;
  If (MyResExportFaxes=MyResExportFaxesToNF) Then
    ExportToNF
End;

Procedure ExportTo1F;
Var NExportFax  : Integer;
    NExportPage : Integer;
Begin
  StartTraceExport;
  NExportPage:=1;
  NExportPages:=1;
  DExportPage:=NExportPage;
  For NExportFax:=1 To NExportFaxes Do
    Begin
      DExportFax:=NExportFax;
      ExportFaxFileName:=ExportNames[NExportFax];
      If FormExport.RadioButtonExportToBMP.Checked Then
        ExportThisFaxTotal(ExportFaxFileName,
                           ExportFileNrBMP,
                           ExportFileForBMP,
                           'B',
                           ExportStatus);
      (* DCX-EXPORT
      If FormExport.RadioButtonExportToDCX.Checked Then
        ExportThisFaxTotal(ExportFaxFileName,
                           ExportFileNrDCX,
                           ExportFileForDCX,
                           'D',
                           ExportStatus);
      *)
      If FormExport.RadioButtonExportToPCX.Checked Then
        ExportThisFaxTotal(ExportFaxFileName,
                           ExportFileNrPCX,
                           ExportFileForPCX,
                           'P',
                           ExportStatus);
      If FormExport.RadioButtonExportToTIFF.Checked Then
        ExportThisFaxTotal(ExportFaxFileName,
                           ExportFileNrTIFF,
                           ExportFileForTIFF,
                           'T',
                           ExportStatus)
    End;
  StopTraceExport
End;

Procedure ExportToNF;
Var NExportFax  : Integer;
    NExportPage : Integer;
Begin
  StartTraceExport;
  For NExportFax:=1 To NExportFaxes Do
    Begin
      DExportFax:=NExportFax;
      ExportFaxFileName:=ExportNames[NExportFax];
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      NExportPages:=FormExport.ApdFaxUnpacker.NumPages;
      If FormExport.RadioButtonExportToBMP.Checked Then
        For NExportPage:=1 To NExportPages Do
          Begin
            DExportPage:=NExportPage;
            ExportThisFaxPage(ExportFaxFileName,
                              ExportFileNrBMP,
                              ExportFileForBMP,
                              NExportPage,
                              'B',
                              ExportStatus)
            End;
      (* DCX-EXPORT
      If FormExport.RadioButtonExportToDCX.Checked Then
        For NExportPage:=1 To NExportPages Do
          ExportThisFaxPage(ExportFaxFileName,
                            ExportFileNrDCX,
                            ExportFileForDCX,
                            NExportPage,
                            'D',
                            ExportStatus);
      *)
      If FormExport.RadioButtonExportToPCX.Checked Then
        For NExportPage:=1 To NExportPages Do
          Begin
            DExportPage:=NExportPage;
            ExportThisFaxPage(ExportFaxFileName,
                              ExportFileNrPCX,
                              ExportFileForPCX,
                              NExportPage,
                              'P',
                              ExportStatus)
          End;
      If FormExport.RadioButtonExportToTIFF.Checked Then
        For NExportPage:=1 To NExportPages Do
          Begin
            DExportPage:=NExportPage;
            ExportThisFaxPage(ExportFaxFileName,
                              ExportFileNrTIFF,
                              ExportFileForTIFF,
                              NExportPage,
                              'T',
                              ExportStatus)
          End
    End;
  StopTraceExport
End;

Procedure ExportThisFaxPage(FaxFileName  : String;
                            Var FileNr   : LongInt;
                            ExpFilePren  : String;
                            PageNr       : LongInt;
                            UnpackType   : Char;
                            Var Status   : Boolean);
Begin
  FileStrNr:=IntToStr(FileNr);
  Inc(FileNr);
  If Not(FileExists(FaxFileName)) Then
    Exit;
  While Length(FileStrNr)<5 Do
    FileStrNr:='0'+FileStrNr;
  Case UnpackType Of
    'B' : FileStrNr:=FileStrNr+'.'+ExtensionBMP;
    'D' : FileStrNr:=FileStrNr+'.'+ExtensionDCX;
    'P' : FileStrNr:=FileStrNr+'.'+ExtensionPCX;
    'T' : FileStrNr:=FileStrNr+'.'+ExtensionTIFF
  End;
  FileStrNr:=ExpFilePren+FileStrNr;
  DExportFax:=1;
  DExportPage:=PageNr;
  FormExport.ApdFaxUnpacker.InFileName:=FaxFileName;
  FormExport.ApdFaxUnpacker.OutFileName:=FileStrNr;
  ExportTraceFaxIn:=Copy(FaxFileName,Length(FaxFileName)-11,12);
  ExportTraceFaxOut:=Copy(FileStrNr,Length(FileStrNr)-11,12);
  SetExportZoomWork;
  Case UnpackType Of
    'B' : FormExport.ApdFaxUnpacker.UnpackPageToBMP(PageNr);
    'D' : FormExport.ApdFaxUnpacker.UnpackPageToDCX(PageNr);
    'P' : FormExport.ApdFaxUnpacker.UnpackPageToPCX(PageNr);
    'T' : FormExport.ApdFaxUnpacker.UnpackPageToTIFF(PageNr)
  End
End;

Procedure ExportThisFaxTotal(FaxFileName : String;
                             Var FileNr  : LongInt;
                             ExpFilePren : String;
                             UnpackType  : Char;
                             Var Status  : Boolean);
Begin
  FileStrNr:=IntToStr(FileNr);
  Inc(FileNr);
  If Not(FileExists(FaxFileName)) Then
    Exit;
  While Length(FileStrNr)<5 Do
    FileStrNr:='0'+FileStrNr;
  Case UnpackType Of
    'B' : FileStrNr:=FileStrNr+'.'+ExtensionBMP;
    'D' : FileStrNr:=FileStrNr+'.'+ExtensionDCX;
    'P' : FileStrNr:=FileStrNr+'.'+ExtensionPCX;
    'T' : FileStrNr:=FileStrNr+'.'+ExtensionTIFF
  End;
  FileStrNr:=ExpFilePren+FileStrNr;
  FormExport.ApdFaxUnpacker.InFileName:=FaxFileName;
  FormExport.ApdFaxUnpacker.OutFileName:=FileStrNr;
  ExportTraceFaxIn:=Copy(FaxFileName,Length(FaxFileName)-11,12);
  ExportTraceFaxOut:=Copy(FileStrNr,Length(FileStrNr)-11,12);
  SetExportZoomWork;
  Case UnpackType Of
    'B' : FormExport.ApdFaxUnpacker.UnpackFileToBMP;
    'D' : FormExport.ApdFaxUnpacker.UnpackFileToDCX;
    'P' : FormExport.ApdFaxUnpacker.UnpackFileToPCX;
    'T' : FormExport.ApdFaxUnpacker.UnpackFileToTIFF
  End
End;

Procedure CheckFileName(Var ExportFile : String;
                        Var ExportNr   : LongInt;
                        Var CheckName  : Integer;
                            Extension  : String);
Begin
  ExportFile:=UpperCase(ExportFile);
  If (Length(ExportFile)<12) Then
    Exit;
  FileStrNr:=Copy(ExportFile,Length(ExportFile)-8,5);
  ExportFile:=Copy(ExportFile,1,Length(ExportFile)-9);
  Val(FileStrNr,ExportNr,CheckName)
End;

Procedure ManuallyExport;
Var NExportFax : Integer;
Begin
  StartTraceExport;
  For NExportFax:=1 To NExportFaxes Do
    Begin
      DExportFax:=NExportFax;
      ExportFaxFileName:=ExportNames[NExportFax];
      If (MyResExportFaxes=MyResExportFaxesTo1F) Then
        ExportTo1FManually;
      If (MyResExportFaxes=MyResExportFaxesToNF) Then
        ExportToNFManually
    End;
  StopTraceExport;
End;

Procedure ExportTo1FManually;
Var NExportPage : Integer;
Begin
  If FormExport.RadioButtonExportToBMP.Checked Then
    Begin
      Repeat
        ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
        FormExport.SaveDialogExport.Title:='Dateiname [*.BMP] des Faxes '+
                                           ExportTraceFaxIn;
        FormExport.SaveDialogExport.Filter:='Dateiname fr BMP|*.BMP';
        If NewExportNameBMP Then
          Begin
            FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                  ExtensionBMP;
            NewExportNameBMP:=False
          End;
        If Not(FormExport.SaveDialogExport.Execute) Then
          Begin
            RestartExport:=True;
            Exit
          End;
        ExportFileForBMP:=FormExport.SaveDialogExport.FileName;
        FileNameOK:=0;
        If (Length(ExportFileForBMP)>11) Then
          ExportTraceFaxOut:=Copy(ExportFileForBMP,Length(ExportFileForBMP)-11,
                                  12)
        Else
          ExportTraceFaxOut:=ExportFileForBMP;
        EraseUpToBackSlash(ExportTraceFaxOut)
      Until (FileNameOK=0);
      NExportPage:=1;
      NExportPages:=1;
      DExportPage:=NExportPage;
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForBMP;
      SetExportZoomWork;
      FormExport.ApdFaxUnpacker.UnpackFileToBMP
    End;
  (* DCX-EXPORT
  If FormExport.RadioButtonExportToDCX.Checked Then
    Begin
      Repeat
        ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
        FormExport.SaveDialogExport.Title:='Dateiname [*.DCX] des Faxes '+
                                           ExportTraceFaxIn;
        FormExport.SaveDialogExport.Filter:='Dateiname fr DCX|*.DCX';
        If NewExportNameDCX Then
          Begin
            FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                  ExtensionDCX;
            NewExportNameDCX:=False
          End;
        If Not(FormExport.SaveDialogExport.Execute) Then
          Begin
            RestartExport:=True;
            Exit
          End;
        ExportFileForDCX:=FormExport.SaveDialogExport.FileName;
        FileNameOK:=0;
        If (Length(ExportFileForDCX)>11) Then
          ExportTraceFaxOut:=Copy(ExportFileForDCX,Length(ExportFileForDCX)-11,
                                  12)
        Else
          ExportTraceFaxOut:=ExportFileForDCX;
        EraseUpToBackSlash(ExportTraceFaxOut)
      Until (FileNameOK=0);
      NExportPage:=1;
      NExportPages:=1;
      DExportPage:=NExportPage;
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForDCX;
      SetExportZoomWork;
      FormExport.ApdFaxUnpacker.UnpackFileToDCX
    End;
  *)
  If FormExport.RadioButtonExportToPCX.Checked Then
    Begin
      Repeat
        ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
        FormExport.SaveDialogExport.Title:='Dateiname [*.PCX] des Faxes '+
                                           ExportTraceFaxIn;
        FormExport.SaveDialogExport.Filter:='Dateiname fr PCX|*.PCX';
        If NewExportNamePCX Then
          Begin
            FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                  ExtensionPCX;
            NewExportNamePCX:=False
          End;
        If Not(FormExport.SaveDialogExport.Execute) Then
          Begin
            RestartExport:=True;
            Exit
          End;
        ExportFileForPCX:=FormExport.SaveDialogExport.FileName;
        FileNameOK:=0;
        If (Length(ExportFileForPCX)>11) Then
          ExportTraceFaxOut:=Copy(ExportFileForPCX,Length(ExportFileForPCX)-11,
                                  12)
        Else
          ExportTraceFaxOut:=ExportFileForPCX;
        EraseUpToBackSlash(ExportTraceFaxOut)
      Until (FileNameOK=0);
      NExportPage:=1;
      NExportPages:=1;
      DExportPage:=NExportPage;
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForPCX;
      SetExportZoomWork;
      FormExport.ApdFaxUnpacker.UnpackFileToPCX
    End;
  If FormExport.RadioButtonExportToTIFF.Checked Then
    Begin
      Repeat
        ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
        FormExport.SaveDialogExport.Title:='Dateiname [*.TIF] des Faxes '+
                                           ExportTraceFaxIn;
        FormExport.SaveDialogExport.Filter:='Dateiname fr TIFF|*.TIF';
        If NewExportNameTIFF Then
          Begin
            FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                  ExtensionTIFF;
            NewExportNameTIFF:=False
          End;
        If Not(FormExport.SaveDialogExport.Execute) Then
          Begin
            RestartExport:=True;
            Exit
          End;
        ExportFileForTIFF:=FormExport.SaveDialogExport.FileName;
        FileNameOK:=0;
        If (Length(ExportFileForTIFF)>11) Then
          ExportTraceFaxOut:=Copy(ExportFileForTIFF,Length(ExportFileForTIFF)-11,
                                  12)
        Else
          ExportTraceFaxOut:=ExportFileForTIFF;
        EraseUpToBackSlash(ExportTraceFaxOut)
      Until (FileNameOK=0);
      NExportPage:=1;
      NExportPages:=1;
      DExportPage:=NExportPage;
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForTIFF;
      SetExportZoomWork;
      FormExport.ApdFaxUnpacker.UnpackFileToTIFF
    End
End;

Procedure ExportToNFManually;
Var NExportPage : Integer;
Begin
  If FormExport.RadioButtonExportToBMP.Checked Then
    Begin
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      NExportPages:=FormExport.ApdFaxUnpacker.NumPages;
      For NExportPage:=1 To NExportPages Do
        Begin
          DExportPage:=NExportPage;
          Repeat
            ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
            FormExport.SaveDialogExport.Title:='Dateiname [*.BMP] des Faxes '+
                                                ExportTraceFaxIn+
                                                'Seite '+
                                                IntToStr(NExportPage)+
                                                ' von '+
                                                IntToStr(NExportPages);
            FormExport.SaveDialogExport.Filter:='Dateiname fr BMP|*.BMP';
            If NewExportNameBMP Then
              Begin
                FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                      ExtensionBMP;
                NewExportNameBMP:=False
              End;
            If Not(FormExport.SaveDialogExport.Execute) Then
              Begin
                RestartExport:=True;
                Exit
              End;
            ExportFileForBMP:=FormExport.SaveDialogExport.FileName;
            FileNameOK:=0;
            If (Length(ExportFileForBMP)>11) Then
              ExportTraceFaxOut:=Copy(ExportFileForBMP,Length(ExportFileForBMP)-11,
                                      12)
            Else
              ExportTraceFaxOut:=ExportFileForBMP;
            EraseUpToBackSlash(ExportTraceFaxOut)
          Until (FileNameOK=0);
          FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
          FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForBMP;
          SetExportZoomWork;
          DExportPage:=NExportPage;
          FormExport.ApdFaxUnpacker.UnpackPageToBMP(NExportPage)
        End
    End;
  (* DCX-EXPORT
  If FormExport.RadioButtonExportToDCX.Checked Then
    Begin
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      NExportPages:=FormExport.ApdFaxUnpacker.NumPages;
      For NExportPage:=1 To NExportPages Do
        Begin
          DExportPage:=NExportPage;
          Repeat
            ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
            FormExport.SaveDialogExport.Title:='Dateiname [*.DCX] des Faxes '+
                                                ExportTraceFaxIn+
                                                'Seite '+
                                                IntToStr(NExportPage)+
                                                ' von '+
                                                IntToStr(NExportPages);
            FormExport.SaveDialogExport.Filter:='Dateiname fr DCX|*.DCX';
            If NewExportNameDCX Then
              Begin
                FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                      ExtensionDCX;
                NewExportNameDCX:=False
              End;
            If Not(FormExport.SaveDialogExport.Execute) Then
              Begin
                RestartExport:=True;
                Exit
              End;
            ExportFileForDCX:=FormExport.SaveDialogExport.FileName;
            FileNameOK:=0;
            If (Length(ExportFileForDCX)>11) Then
              ExportTraceFaxOut:=Copy(ExportFileForDCX,Length(ExportFileForDCX)-11,
                                      12)
            Else
              ExportTraceFaxOut:=ExportFileForDCX;
            EraseUpToBackSlash(ExportTraceFaxOut)
          Until (FileNameOK=0);
          FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
          FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForDCX;
          SetExportZoomWork;
          DExportPage:=NExportPage;
          FormExport.ApdFaxUnpacker.UnpackPageToDCX(NExportPage)
        End
    End;
  *)
  If FormExport.RadioButtonExportToPCX.Checked Then
    Begin
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      NExportPages:=FormExport.ApdFaxUnpacker.NumPages;
      For NExportPage:=1 To NExportPages Do
        Begin
          DExportPage:=NExportPage;
          Repeat
            ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
            FormExport.SaveDialogExport.Title:='Dateiname [*.PCX] des Faxes '+
                                                ExportTraceFaxIn+
                                                'Seite '+
                                                IntToStr(NExportPage)+
                                                ' von '+
                                                IntToStr(NExportPages);
            FormExport.SaveDialogExport.Filter:='Dateiname fr PCX|*.PCX';
            If NewExportNamePCX Then
              Begin
                FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                      ExtensionPCX;
                NewExportNamePCX:=False
              End;
            If Not(FormExport.SaveDialogExport.Execute) Then
              Begin
                RestartExport:=True;
                Exit
              End;
            ExportFileForPCX:=FormExport.SaveDialogExport.FileName;
            FileNameOK:=0;
            If (Length(ExportFileForPCX)>11) Then
              ExportTraceFaxOut:=Copy(ExportFileForPCX,Length(ExportFileForPCX)-11,
                                      12)
            Else
              ExportTraceFaxOut:=ExportFileForPCX;
            EraseUpToBackSlash(ExportTraceFaxOut)
          Until (FileNameOK=0);
          FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
          FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForPCX;
          SetExportZoomWork;
          DExportPage:=NExportPage;
          FormExport.ApdFaxUnpacker.UnpackPageToPCX(NExportPage)
        End
    End;
  If FormExport.RadioButtonExportToTIFF.Checked Then
    Begin
      FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
      NExportPages:=FormExport.ApdFaxUnpacker.NumPages;
      For NExportPage:=1 To NExportPages Do
        Begin
          DExportPage:=NExportPage;
          Repeat
            ExportTraceFaxIn:=Copy(ExportFaxFileName,Length(ExportFaxFileName)-11,12);
            FormExport.SaveDialogExport.Title:='Dateiname [*.TIF] des Faxes '+
                                                ExportTraceFaxIn+
                                                'Seite '+
                                                IntToStr(NExportPage)+
                                                ' von '+
                                                IntToStr(NExportPages);
            FormExport.SaveDialogExport.Filter:='Dateiname fr TIFF|*.TIF';
            If NewExportNameTIFF Then
              Begin
                FormExport.SaveDialogExport.FileName:=StartPath+DefaultExportFileM+'.'+
                                                      ExtensionTIFF;
                NewExportNameTIFF:=False
              End;
            If Not(FormExport.SaveDialogExport.Execute) Then
              Begin
                RestartExport:=True;
                Exit
              End;
            ExportFileForTIFF:=FormExport.SaveDialogExport.FileName;
            FileNameOK:=0;
            If (Length(ExportFileForTIFF)>11) Then
              ExportTraceFaxOut:=Copy(ExportFileForTIFF,Length(ExportFileForTIFF)-11,
                                      12)
            Else
              ExportTraceFaxOut:=ExportFileForTIFF;
            EraseUpToBackSlash(ExportTraceFaxOut)
          Until (FileNameOK=0);
          FormExport.ApdFaxUnpacker.InFileName:=ExportFaxFileName;
          FormExport.ApdFaxUnpacker.OutFileName:=ExportFileForTIFF;
          SetExportZoomWork;
          DExportPage:=NExportPage;
          FormExport.ApdFaxUnpacker.UnpackPageToTIFF(NExportPage)
        End
    End
End;

Procedure EraseUpToBackSlash(Var S : String);
Begin
  While (Pos('\',S)>0) Do
    S:=Copy(S,2,Length(S)-1)
End;

Procedure PresetExportParameters;
Begin
  FormExport.RadioButtonExportToBMP.Checked:=True;
  FormExport.RadioButtonExportToPCX.Checked:=False;
  FormExport.RadioButtonExportToTIFF.Checked:=False;
  FormExport.RadioButtonManually.Checked:=False;
  FormExport.RadioButtonAutomatic.Checked:=True;
  FaxExportZoomX:=4;
  FaxExportZoomY:=4;
  SetExportZoomDisp;
  FormExport.ScrollBarExportZoomX.Min:=0;
  FormExport.ScrollBarExportZoomX.Max:=7;
  FormExport.ScrollBarExportZoomX.Position:=FaxExportZoomX;
  FormExport.ScrollBarExportZoomY.Min:=0;
  FormExport.ScrollBarExportZoomY.Max:=7;
  FormExport.ScrollBarExportZoomY.Position:=FaxExportZoomY
End;

Procedure SetExportZoomDisp;
Begin
  Case FaxExportZoomX Of
    0 : FormExport.LabelExportZoomXAct.Caption:='10%';
    1 : FormExport.LabelExportZoomXAct.Caption:='20%';
    2 : FormExport.LabelExportZoomXAct.Caption:='33%';
    3 : FormExport.LabelExportZoomXAct.Caption:='50%';
    4 : FormExport.LabelExportZoomXAct.Caption:='100%';
    5 : FormExport.LabelExportZoomXAct.Caption:='150%';
    6 : FormExport.LabelExportZoomXAct.Caption:='200%';
    7 : FormExport.LabelExportZoomXAct.Caption:='250%'
  End;
  Case FaxExportZoomY Of
    0 : FormExport.LabelExportZoomYAct.Caption:='10%';
    1 : FormExport.LabelExportZoomYAct.Caption:='20%';
    2 : FormExport.LabelExportZoomYAct.Caption:='33%';
    3 : FormExport.LabelExportZoomYAct.Caption:='50%';
    4 : FormExport.LabelExportZoomYAct.Caption:='100%';
    5 : FormExport.LabelExportZoomYAct.Caption:='150%';
    6 : FormExport.LabelExportZoomYAct.Caption:='200%';
    7 : FormExport.LabelExportZoomYAct.Caption:='250%'
  End;
  Application.ProcessMessages
End;

Procedure SetExportZoomWork;
Begin
  Case FaxExportZoomX Of
    0 : Begin
          ZoomExportXMult:=1;
          ZoomExportXDiv:=10
        End;
    1 : Begin
          ZoomExportXMult:=1;
          ZoomExportXDiv:=5
        End;
    2 : Begin
          ZoomExportXMult:=1;
          ZoomExportXDiv:=3
        End;
    3 : Begin
          ZoomExportXMult:=1;
          ZoomExportXDiv:=2
        End;
    4 : Begin
          ZoomExportXMult:=1;
          ZoomExportXDiv:=1
        End;
    5 : Begin
          ZoomExportXMult:=3;
          ZoomExportXDiv:=2
        End;
    6 : Begin
          ZoomExportXMult:=2;
          ZoomExportXDiv:=1
        End;
    7 : Begin
          ZoomExportXMult:=5;
          ZoomExportXDiv:=2
        End
   End;
   If (FormExport.ApdFaxUnpacker.FaxResolution=frNormal) Then
     Case FaxExportZoomY Of
       0 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=20
           End;
       1 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=10
           End;
       2 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=6
           End;
       3 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=4
           End;
       4 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=2
           End;
       5 : Begin
             ZoomExportYMult:=3;
             ZoomExportYDiv:=4
           End;
       6 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=1
           End;
       7 : Begin
             ZoomExportYMult:=5;
             ZoomExportYDiv:=4
           End
     End;
   If (FormExport.ApdFaxUnpacker.FaxResolution=frHigh) Then
     Case FaxExportZoomY Of
       0 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=40
           End;
       1 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=20
           End;
       2 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=12
           End;
       3 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=8
           End;
       4 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=4
           End;
       5 : Begin
             ZoomExportYMult:=3;
             ZoomExportYDiv:=8
           End;
       6 : Begin
             ZoomExportYMult:=1;
             ZoomExportYDiv:=2
           End;
       7 : Begin
             ZoomExportYMult:=5;
             ZoomExportYDiv:=8
           End
     End;
   FormExport.ApdFaxUnpacker.Scaling:=True;
   FormExport.ApdFaxUnpacker.HorizMult:=ZoomExportXMult;
   FormExport.ApdFaxUnpacker.HorizDiv:=ZoomExportXDiv;
   FormExport.ApdFaxUnpacker.VertMult:=ZoomExportYMult;
   FormExport.ApdFaxUnpacker.VertDiv:=ZoomExportYDiv
End;

procedure TFormExport.BitBtnExportQuitClick(Sender: TObject);
begin
  MyResExportFaxes:=MyResExportFaxesQuit;
  ModalResult:=mrOK
end;

procedure TFormExport.SpeedButtonExportTo1FileClick(Sender: TObject);
begin
  MyResExportFaxes:=MyResExportFaxesTo1F;
  ModalResult:=mrOK
end;

procedure TFormExport.SpeedButtonExportToNFilesClick(Sender: TObject);
begin
  MyResExportFaxes:=MyResExportFaxesToNF;
  ModalResult:=mrOK
end;

procedure TFormExport.ApdFaxUnpackerStatus(Sender: TObject; FName: String;
  PageNum: Integer; BytesUnpacked, BytesToUnpack: Longint);
begin
  FormExportTrace.LabelExportFileIn.Caption:=ExportTraceFaxIn;
  FormExportTrace.LabelExportFileOut.Caption:=ExportTraceFaxOut;
  FormExportTrace.GaugeTotalFiles.MinValue:=0;
  FormExportTrace.GaugeTotalFiles.MaxValue:=NExportFaxes;
  FormExportTrace.GaugeTotalFiles.Progress:=DExportFax;
  FormExportTrace.GaugeInPages.MinValue:=0;
  FormExportTrace.GaugeInPages.MaxValue:=NExportPages;
  FormExportTrace.GaugeInPages.Progress:=DExportPage;
  FormExportTrace.GaugeInPage.MinValue:=0;
  FormExportTrace.GaugeInPage.MaxValue:=BytesToUnpack;
  FormExportTrace.GaugeInPage.Progress:=BytesUnpacked
end;

procedure TFormExport.ScrollBarExportZoomXChange(Sender: TObject);
begin
  FaxExportZoomX:=FormExport.ScrollBarExportZoomX.Position;
  SetExportZoomDisp
End;

procedure TFormExport.ScrollBarExportZoomYChange(Sender: TObject);
begin
  FaxExportZoomY:=FormExport.ScrollBarExportZoomY.Position;
  SetExportZoomDisp
end;

end.
