unit Unitfaxv;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Unitglob,
  Unittool,
  Unitlisf,
  Unitidfi,
  Unitpsta,
  Unitexpo, ExtCtrls, AdFView, Buttons, StdCtrls, AdFaxPrn, AdFPStat, Menus;

type
  TFormFaxViewer = class(TForm)
    FaxViewer: TApdFaxViewer;
    PanelFaxViewMenu: TPanel;
    SpeedButtonQuitFaxViewer: TSpeedButton;
    BevelFaxBF: TBevel;
    BevelFaxenBF: TBevel;
    SpeedButtonBackFax: TSpeedButton;
    SpeedButtonForwardFax: TSpeedButton;
    SpeedButtonFax1stPage: TSpeedButton;
    SpeedButtonFaxBackPage: TSpeedButton;
    SpeedButtonFaxForwardPage: TSpeedButton;
    BevelFaxTools: TBevel;
    SpeedButtonZoomOut: TSpeedButton;
    SpeedButtonZoomIn: TSpeedButton;
    SpeedButtonMoveMenu: TSpeedButton;
    SpeedButtonRorateFax: TSpeedButton;
    BevelFaxInfo: TBevel;
    LabelViewFaxIdent: TLabel;
    LabelViewFaxName: TLabel;
    LabelViewFaxPageNr: TLabel;
    LabelViewFaxDatum: TLabel;
    BevelFaxPrintExport: TBevel;
    SpeedButtonPrintThisFax: TSpeedButton;
    SpeedButtonExportFax: TSpeedButton;
    MenuViewer: TMainMenu;
    MenuViewerFile: TMenuItem;
    MenuViewerQuit: TMenuItem;
    MenuViewerPaging: TMenuItem;
    MenuViewerZoom: TMenuItem;
    MenuVierwerPrint: TMenuItem;
    MenuViewerPrevPage: TMenuItem;
    MenuViewerNextPage: TMenuItem;
    MenuViewerPrevFax: TMenuItem;
    MenuViewerNextFax: TMenuItem;
    MenuViewer1StPage: TMenuItem;
    MenuViewerZoom10: TMenuItem;
    MenuViewerZoom20: TMenuItem;
    MenuViewerZoom33: TMenuItem;
    MenuViewerZoom50: TMenuItem;
    MenuViewerZoom100: TMenuItem;
    MenuViewerZoom150: TMenuItem;
    MenuViewerZoom200: TMenuItem;
    MenuViewerZoom250: TMenuItem;
    MenuViewerZoom300: TMenuItem;
    MenuViewerPrint: TMenuItem;
    MenuViewerRotate: TMenuItem;
    procedure SpeedButtonQuitFaxViewerClick(Sender: TObject);
    procedure SpeedButtonFax1stPageClick(Sender: TObject);
    procedure SpeedButtonBackFaxClick(Sender: TObject);
    procedure SpeedButtonForwardFaxClick(Sender: TObject);
    procedure SpeedButtonFaxBackPageClick(Sender: TObject);
    procedure SpeedButtonFaxForwardPageClick(Sender: TObject);
    procedure SpeedButtonZoomOutClick(Sender: TObject);
    procedure SpeedButtonZoomInClick(Sender: TObject);
    procedure SpeedButtonMoveMenuMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButtonMoveMenuMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButtonMoveMenuMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButtonPrintThisFaxClick(Sender: TObject);
    procedure SpeedButtonRorateFaxClick(Sender: TObject);
    procedure MenuViewerQuitClick(Sender: TObject);
    procedure MenuViewerPrintClick(Sender: TObject);
    procedure MenuViewerZoom10Click(Sender: TObject);
    procedure MenuViewerZoom20Click(Sender: TObject);
    procedure MenuViewerZoom33Click(Sender: TObject);
    procedure MenuViewerZoom50Click(Sender: TObject);
    procedure MenuViewerZoom100Click(Sender: TObject);
    procedure MenuViewerZoom150Click(Sender: TObject);
    procedure MenuViewerZoom200Click(Sender: TObject);
    procedure MenuViewerZoom300Click(Sender: TObject);
    procedure MenuViewerZoom250Click(Sender: TObject);
    procedure MenuViewerRotateClick(Sender: TObject);
    procedure MenuViewer1StPageClick(Sender: TObject);
    procedure MenuViewerPrevPageClick(Sender: TObject);
    procedure MenuViewerNextPageClick(Sender: TObject);
    procedure MenuViewerPrevFaxClick(Sender: TObject);
    procedure MenuViewerNextFaxClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButtonExportFaxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormFaxViewer: TFormFaxViewer;

Procedure FaxGlobalViewer;
Procedure ViewSelectedFaxes;
Procedure ZoomNow;
Procedure UpDatePageNr;
Procedure DumpFax;
Procedure ViewThisFax;

implementation

{$R *.DFM}

Procedure FaxGlobalViewer;
Begin
  BuildFaxList;
  While (MyResSelFaxes<>MyResSelFaxesQuit) Do
    Begin
      ViewSelectedFaxes;
      BuildFaxlist
    End;
  HideFaxList
End;

Procedure ViewSelectedFaxes;
Var L_FaxNr : LongInt;
Begin
  OpenReadIDFaxFile;
  If (FormListFaxes.ListBoxFaxes.SelCount=1) Then
    Begin
      FormFaxViewer.SpeedButtonBackFax.Enabled:=False;
      FormFaxViewer.SpeedButtonForwardFax.Enabled:=False;
      FormFaxViewer.MenuViewerPrevFax.Enabled:=False;
      FormFaxViewer.MenuViewerNextFax.Enabled:=False
    End;
  A_FaxNrDispl:=1;
  Repeat
    MyResViewFaxes:=MyResViewFaxesNone;
    A_FaxNrSearch:=0;
    A_FaxNr:=0;
    L_FaxNr:=0;
    Repeat
      Inc(A_FaxNr);
      Inc(L_FaxNr);
      If FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1] Then
        Inc(A_FaxNrSearch)
    Until A_FaxNrSearch=A_FaxNrDispl;
    FormFaxViewer.ShowModal;
    If (MyResViewFaxes=MyResViewFaxesPrint) Then
      Begin
        A_FaxSelected:=1;
        A_FaxNrPrinted:=1;
        DumpFax
      End;
    If (MyResViewFaxes=MyResViewFaxesExport) Then
      Begin
        NExportFaxes:=0;
        For L_FaxNr:=1 To A_NFaxes Do
          If FormListFaxes.ListBoxFaxes.Selected[L_FaxNr-1] Then
            Begin
              A_FaxNr:=L_FaxNr;
              Inc(NExportFaxes);
              SeekAndReadActIDFax(L_FaxNr);
              ExportNames[NExportFaxes]:=BuildFileName(StartPath+FileFaxNamePathPre,
                                                       IDLineFax.FaxNr,
                                                       AllNamePostfix);
            End;
        ExportFaxes
      End
  Until (MyResViewFaxes=MyResViewFaxesQuit);
  CloseIDFaxFile;
  FormFaxViewer.Hide
End;

Procedure ZoomNow;
Begin
  With FormFaxVIewer.FaxViewer Do
    Case FaxRotation Of
      Rot__0   : Rotation:=vr0;
      Rot__90  : Rotation:=vr90;
      Rot__180 : Rotation:=vr180;
      Rot__270 : Rotation:=vr270
    End;
  FormFaxViewer.FaxViewer.HorizMult:=ZoomXMult;
  FormFaxViewer.FaxViewer.HorizDiv:=ZoomXDiv;
  FormFaxViewer.FaxViewer.VertMult:=ZoomYMult;
  FormFaxViewer.FaxViewer.VertDiv:=ZoomYDiv;
  FormFaxViewer.SpeedButtonZoomOut.Enabled:=Not(FaxViewerActZoom=0);
  FormFaxViewer.SpeedButtonZoomIn.Enabled:=Not(FaxViewerActZoom=8);
  FormFaxViewer.Caption:='Fax anschauen (Zoom '+FaxActZoomText+
                         ', Drehung '+FaxRotateText+')'
End;

Procedure UpDatePageNr;
Begin
  IDRow:=IntToStr(FormFaxViewer.FaxViewer.ActivePage)+
         ' ['+
         IntToStr(FormFaxViewer.FaxViewer.NumPages)+
         ']';
  FormFaxViewer.LabelViewFaxPageNr.Caption:='Seite : '+IDRow;
  If (FormFaxViewer.FaxViewer.NumPages>1) Then
    Begin
      If (FormFaxViewer.FaxViewer.ActivePage=1) Then
        Begin
          FormFaxViewer.SpeedButtonFaxBackPage.Enabled:=False;
          FormFaxViewer.MenuViewerPrevPage.Enabled:=False
        End
      Else
        Begin
          FormFaxViewer.SpeedButtonFaxBackPage.Enabled:=True;
          FormFaxViewer.MenuViewerPrevPage.Enabled:=True  
        End;
      If (FormFaxViewer.FaxViewer.ActivePage=FormFaxViewer.FaxViewer.NumPages) Then
        Begin
          FormFaxViewer.SpeedButtonFaxForwardPage.Enabled:=False;
          FormFaxViewer.MenuViewerNextPage.Enabled:=False
        End
      Else
        Begin
          FormFaxViewer.SpeedButtonFaxForwardPage.Enabled:=True;
          FormFaxViewer.MenuViewerNextPage.Enabled:=True
        End
    End
  Else
    Begin
      FormFaxViewer.SpeedButtonFaxBackPage.Enabled:=False;
      FormFaxViewer.SpeedButtonFaxForwardPage.Enabled:=False;
      FormFaxViewer.MenuViewerPrevPage.Enabled:=False;
      FormFaxViewer.MenuViewerNextPage.Enabled:=False
    End;
  If (A_FaxNrSearch=1) Then
    Begin
      FormFaxViewer.SpeedButtonBackFax.Enabled:=False;
      FormFaxViewer.MenuViewerPrevFax.Enabled:=False
    End
  Else
    Begin
      FormFaxViewer.SpeedButtonBackFax.Enabled:=True;
      FormFaxViewer.MenuViewerPrevFax.Enabled:=True
    End;
  If (A_FaxNrSearch=FormListFaxes.ListBoxFaxes.SelCount) Then
    Begin
      FormFaxViewer.SpeedButtonForwardFax.Enabled:=False;
      FormFaxViewer.MenuViewerNextFax.Enabled:=False
    End
  Else
    Begin
      FormFaxViewer.SpeedButtonForwardFax.Enabled:=True;
      FormFaxViewer.MenuViewerNextFax.Enabled:=True
    End
End;

Procedure DumpFax;
Begin
  AskPrinterSetup:=True;
  PrintThisFax;
  MyResViewFaxes:=MyResViewFaxesNone
End;

Procedure ViewThisFax;
Begin
  SeekAndReadActIDFax(A_FaxNr);
  IDLineFax.FaxViewed:=True;
  SeekAndRewriteActIDFax(A_FaxNr);
  A_FaxNr:=IDLineFax.FaxNr;
  A_FaxFileName:=BuildFileName(StartPath+FileFaxNamePathPre,
                               A_FaxNr,
                               AllNamePostfix);
  IDRow:=BuildFileName(FileFaxNamePrefix,
                       A_FaxNr,
                       AllNamePostfix);
  A_DumpName:=IDRow;
  FormFaxViewer.LabelViewFaxName.Caption:='Datei : '+IDRow;
  IDRow:=DateToStr(IDLineFax.FaxTime);
  FormFaxViewer.LabelViewFaxDatum.Caption:='Vom : '+IDRow;
  IDRow:=IDLineFax.FaxIdent;
  FormFaxViewer.LabelViewFaxIdent.Caption:='ID : '+IDRow;
  FormFaxViewer.FaxViewer.BeginUpdate;
  SetNoZoom;
  FormFaxViewer.FaxViewer.FileName:=A_FaxFileName;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate;
  UpDatePageNr
End;

procedure TFormFaxViewer.SpeedButtonQuitFaxViewerClick(Sender: TObject);
begin
  MyResViewFaxes:=MyResViewFaxesQuit;
  ModalResult:=mrOK
end;

procedure TFormFaxViewer.SpeedButtonFax1stPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.FirstPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.SpeedButtonFaxBackPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.PrevPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.SpeedButtonFaxForwardPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.NextPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.SpeedButtonBackFaxClick(Sender: TObject);
begin
  If (A_FaxNrDispl>1) Then
    Dec(A_FaxNrDispl);
  A_FaxNrSearch:=0;
  A_FaxNr:=0;
  Repeat
    Inc(A_FaxNr);
    If FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1] Then
      Inc(A_FaxNrSearch)
  Until A_FaxNrSearch=A_FaxNrDispl;
  ViewThisFax
end;

procedure TFormFaxViewer.SpeedButtonForwardFaxClick(Sender: TObject);
begin
  If (A_FaxNrDispl<FormListFaxes.ListBoxFaxes.SelCount) Then
    Inc(A_FaxNrDispl);
  A_FaxNrSearch:=0;
  A_FaxNr:=0;
  Repeat
    Inc(A_FaxNr);
    If FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1] Then
      Inc(A_FaxNrSearch)
  Until A_FaxNrSearch=A_FaxNrDispl;
  ViewThisFax
end;

procedure TFormFaxViewer.SpeedButtonZoomOutClick(Sender: TObject);
begin
  GetPrevZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.SpeedButtonZoomInClick(Sender: TObject);
begin
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.SpeedButtonMoveMenuMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MoveMenuStartX:=X;
  MoveMenuStartY:=Y;
  ViewerMouseStatus:=True
end;

procedure TFormFaxViewer.SpeedButtonMoveMenuMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  If ViewerMouseStatus Then
    Begin
      PanelFaxViewMenu.Left:=PanelFaxViewMenu.Left+X-MoveMenuStartX;
      PanelFaxViewMenu.Top:=PanelFaxViewMenu.Top+Y-MoveMenuStartY
    End
end;

procedure TFormFaxViewer.SpeedButtonMoveMenuMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ViewerMouseStatus:=False
end;

procedure TFormFaxViewer.SpeedButtonPrintThisFaxClick(Sender: TObject);
begin
  MyResViewFaxes:=MyResViewFaxesPrint;
  ModalResult:=mrOK
end;

procedure TFormFaxViewer.SpeedButtonRorateFaxClick(Sender: TObject);
begin
  GetNextRotateAngle;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerQuitClick(Sender: TObject);
begin
  MyResViewFaxes:=MyResViewFaxesQuit;
  ModalResult:=mrOK
end;

procedure TFormFaxViewer.MenuViewerPrintClick(Sender: TObject);
begin
  MyResViewFaxes:=MyResViewFaxesPrint;
  ModalResult:=mrOK
end;

procedure TFormFaxViewer.MenuViewerZoom10Click(Sender: TObject);
begin
  FaxViewerActZoom:=1;
  GetPrevZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom20Click(Sender: TObject);
begin
  FaxViewerActZoom:=0;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom33Click(Sender: TObject);
begin
  FaxViewerActZoom:=1;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom50Click(Sender: TObject);
begin
  FaxViewerActZoom:=2;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom100Click(Sender: TObject);
begin
  FaxViewerActZoom:=3;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom150Click(Sender: TObject);
begin
  FaxViewerActZoom:=4;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom200Click(Sender: TObject);
begin
  FaxViewerActZoom:=5;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom250Click(Sender: TObject);
begin
  FaxViewerActZoom:=6;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerZoom300Click(Sender: TObject);
begin
  FaxViewerActZoom:=7;
  GetNextZoom;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewerRotateClick(Sender: TObject);
begin
  GetNextRotateAngle;
  FormFaxViewer.FaxViewer.BeginUpdate;
  ZoomNow;
  FormFaxViewer.FaxViewer.EndUpdate
end;

procedure TFormFaxViewer.MenuViewer1StPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.FirstPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.MenuViewerPrevPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.PrevPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.MenuViewerNextPageClick(Sender: TObject);
begin
  FormFaxViewer.FaxViewer.NextPage;
  UpDatePageNr
end;

procedure TFormFaxViewer.MenuViewerPrevFaxClick(Sender: TObject);
begin
  If (A_FaxNrDispl>1) Then
    Begin
      Dec(A_FaxNrDispl);
      MyResViewFaxes:=MyResViewFaxesRefr
    End
end;

procedure TFormFaxViewer.MenuViewerNextFaxClick(Sender: TObject);
begin
  If (A_FaxNrDispl<FormListFaxes.ListBoxFaxes.SelCount) Then
    Begin
      Inc(A_FaxNrDispl);
      MyResViewFaxes:=MyResViewFaxesRefr
    End
end;

procedure TFormFaxViewer.FormShow(Sender: TObject);
begin
  ViewThisFax
end;

procedure TFormFaxViewer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If MyResViewFaxes=MyResViewFaxesNone Then
    MyResViewFaxes:=MyResViewFaxesQuit;
  ModalResult:=mrOK
end;

procedure TFormFaxViewer.SpeedButtonExportFaxClick(Sender: TObject);
begin
  MyResViewFaxes:=MyResViewFaxesExport;
  ModalResult:=mrOK
end;

end.
