unit Unitflas;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, Gauges, StdCtrls,
  Unitglob,
  Unitcomp,
  Unittool,
  Unittime,
  Unitflwa,
  Unitflax,
  Unithshk,
  Unitoton, Menus;

type
  TFormDownloadFlash = class(TForm)
    OpenDialogFirmFile: TOpenDialog;
    SpeedButtonDefFirmFile: TSpeedButton;
    GaugeFirmwareCount1: TGauge;
    GaugeFirmwareCount2: TGauge;
    GaugeFirmwareCount3: TGauge;
    GaugeFirmwareCount4: TGauge;
    LabelFirmware1: TLabel;
    LabelFirmware2: TLabel;
    LabelFirmware3: TLabel;
    LabelFirmware4: TLabel;
    LabelFirmwareStatus: TLabel;
    MenuDownload: TMainMenu;
    MenuDownloadFile: TMenuItem;
    MenuDownloadSetFile: TMenuItem;
    MenuDownloadQuit: TMenuItem;
    BitBtnQuitFirmFile: TBitBtn;
    BevelStatusDownload: TBevel;
    procedure SpeedButtonDefFirmFileClick(Sender: TObject);
    procedure BitBtnQuitFirmFileClick(Sender: TObject);
    procedure MenuDownloadSetFileClick(Sender: TObject);
    procedure MenuDownloadQuitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormDownloadFlash: TFormDownloadFlash;

Procedure DownloadAllInFlash;

implementation

{$R *.DFM}

Procedure DownloadAllInFlash;
Var FirmWareBlock : LongInt;
    FirmWareCount : LongInt;
Begin
  MyResFileDef:=MyResFileDefNone;
  FormDownloadFlash.Show;
  FirmwareStatus:=False;
  FormDownloadFlash.SpeedButtonDefFirmFile.Enabled:=True;
  FormDownloadFlash.BitBtnQuitFirmFile.Enabled:=True;
  FormDownloadFlash.MenuDownloadFile.Enabled:=True;
  Repeat
    Repeat
      Application.ProcessMessages
    Until (MyResFileDef<>MyResFileDefNone);
    If (MyResFileDef=MyResFileDefQuit) Then
      Begin
        FormDownloadFlash.Hide;
        Exit
      End;
    RebootFirmware:=True;
    AssignFile(FirmwareFile,FirmwareFileName);
    Try
      Reset(FirmwareFile,1);
      Try
        If (FileSize(FirmwareFile)=FirmwareFileLength) Then
          FirmwareStatus:=True
        Finally
        End
    Except
      FirmwareStatus:=False
    End;
    If FirmwareStatus Then
      Begin
        BlockRead(FirmwareFile,BinaryBuffer,FirmwareBufferLen);
        NewStrVersion:=Chr(BinaryBuffer[NewFirmwareN_Pos1])+'.'+
                       Chr(BinaryBuffer[NewFirmwareN_Pos2])+
                       Chr(BinaryBuffer[NewFirmwareN_Pos3])+
                       Chr(BinaryBuffer[NewFirmwareL_Pos1]);
        NewNumVersion:=BinaryBuffer[NewFirmwareN_Pos1]*100+
                       BinaryBuffer[NewFirmwareN_Pos2]*10+
                       BinaryBuffer[NewFirmwareN_Pos3];
        NewLangVersion:=Chr(BinaryBuffer[NewFirmwareL_Pos1]);
        Reset(FirmwareFile,1);
        AskOldToNew
      End
  Until FirmwareStatus;
  FormHandshake.Show;
  FormDownloadFlash.SpeedButtonDefFirmFile.Enabled:=False;
  FormDownloadFlash.BitBtnQuitFirmFile.Enabled:=False;
  FormDownloadFlash.MenuDownloadFile.Enabled:=False;
  AskAndRead1s('@');
  If DeviceFailure Then
    Begin
      FormDownloadFlash.Hide;
      Exit
    End;
  RemoveChar(InputString,Cr);
  If (InputString<>'S?') Then
    Begin
      DeviceFailure:=True;
      FormDownloadFlash.Hide;
      Exit
    End;
  AskAndRead1s('A');
  WaitAndRead16s;
  RemoveChar(InputString,Cr);
  FormHandshake.Hide;
  If (InputString<>'OK') Then
    Begin
      DeviceFailure:=True;
      FormDownloadFlash.Hide;
      Exit
    End;
  FormDownloadFlash.GaugeFirmwareCount1.MinValue:=0;
  FormDownloadFlash.GaugeFirmwareCount2.MinValue:=0;
  FormDownloadFlash.GaugeFirmwareCount3.MinValue:=0;
  FormDownloadFlash.GaugeFirmwareCount4.MinValue:=0;
  FormDownloadFlash.GaugeFirmwareCount1.MaxValue:=FlashBankBlocks;
  FormDownloadFlash.GaugeFirmwareCount2.MaxValue:=FlashBankBlocks;
  FormDownloadFlash.GaugeFirmwareCount3.MaxValue:=FlashBankBlocks;
  FormDownloadFlash.GaugeFirmwareCount4.MaxValue:=FlashBankBlocks;
  FormDownloadFlash.GaugeFirmwareCount1.Progress:=0;
  FormDownloadFlash.GaugeFirmwareCount2.Progress:=0;
  FormDownloadFlash.GaugeFirmwareCount3.Progress:=0;
  FormDownloadFlash.GaugeFirmwareCount4.Progress:=0;
  For FirmwareBlock:=1 To 4 Do
    Begin
      OutRecordLen:=FirmwareBufferLen;
      For FirmwareCount:=1 To FlashBankBlocks Do
        Begin
          Case FirmwareBlock Of
            1 : FormDownloadFlash.GaugeFirmwareCount1.Progress:=FirmwareCount;
            2 : FormDownloadFlash.GaugeFirmwareCount2.Progress:=FirmwareCount;
            3 : FormDownloadFlash.GaugeFirmwareCount3.Progress:=FirmwareCount;
            4 : FormDownloadFlash.GaugeFirmwareCount4.Progress:=FirmwareCount
          End;
          BlockRead(FirmwareFile,BinaryBuffer,FirmwareBufferLen);
          Repeat
          Until (GetOutFree>FirmwareBufferLen);
          PutComArray;
          FormDownloadFlash.Show
        End;
      WaitAndRead16s;
      RemoveChar(InputString,Cr);
      If (DeviceFailure Or (InputString<>'B')) Then
        Begin
          DeviceFailure:=True;
          FormDownloadFlash.Hide;
          Exit
        End
    End;
  FlashWarning;
  If (FormFirmwareWarning.ModalResult=MyResFirmWarnBreak) Then
    Begin
      PutComString('X');
      DoneXFirmware:=True;
      Exit
    End;
  FlashBomb;
  AskAndRead1s('P');
  RemoveChar(InputString,Cr);
  If (InputString<>'P!') Then
    Begin
      DeviceFailure:=True;
      FormDownloadFlash.Hide;
      Exit
    End;
  FormDownloadFlash.Hide;
  DoneXFirmware:=True
End;

procedure TFormDownloadFlash.SpeedButtonDefFirmFileClick(Sender: TObject);
begin
  OpenDialogFirmFile.DefaultExt:=FirmwareExtension;
  OpenDialogFirmFile.FileName:='';
  OpenDialogFirmFile.Filter:='Firmware|*.'+FirmwareExtension+'|'+
                             'Alle Dateien|*.*';
  OpenDialogFirmFile.Execute;
  If OpenDialogFirmFile.FileName<>'' Then
    Begin
      FirmwareFileName:=OpenDialogFirmFile.FileName;
      MyResFileDef:=MyResFileDefOkay
    End
end;

procedure TFormDownloadFlash.BitBtnQuitFirmFileClick(Sender: TObject);
begin
   MyResFileDef:=MyResFileDefQuit
end;

procedure TFormDownloadFlash.MenuDownloadSetFileClick(Sender: TObject);
begin
  OpenDialogFirmFile.DefaultExt:=FirmwareExtension;
  OpenDialogFirmFile.FileName:='';
  OpenDialogFirmFile.Filter:='Firmware|*.'+FirmwareExtension+'|'+
                             'Alle Dateien|*.*';
  OpenDialogFirmFile.Execute;
  If OpenDialogFirmFile.FileName<>'' Then
    Begin
      FirmwareFileName:=OpenDialogFirmFile.FileName;
      MyResFileDef:=MyResFileDefOkay
    End
end;

procedure TFormDownloadFlash.MenuDownloadQuitClick(Sender: TObject);
begin
   MyResFileDef:=MyResFileDefQuit
end;

procedure TFormDownloadFlash.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   MyResFileDef:=MyResFileDefQuit
end;

end.
