unit Unitglob;

interface

uses ExtCtrls;

(*
***************************************************************************************************
                                          Firmware Versions

2.00 ... xx.xx.1997 ... - Basic version for testing ICO & JEPAZ derived from CONTROL for MagicFax.
2.01 ...                - First public Version
2.02 ... 13.03.2000 ... - Win98/95 Version - because loop-counter variables must be local,
                          changed on places, where necessary. This cause less nice source,
                          but I have no more power to make bigger and nicer changes.
                        - DUMMY-mode enabled
2.03 ... 20.03.2000 ... - all serial communication done with APro exchanged into Async32.
                          APro is bad for SIO transfers.
                        - in Setup-Form all components are disabled, if not known by Safer/MemoFax,
                          that means - if not transfered appropriate string
                        - in more forms are edit-objects disabled, but should be enabled AND
                          read-only. Was corrected.
                        - when faxes in memory, there is a question, if by setup faxes can be
                          erased. This question was bad tested - was corrected.                          
---------------------------------------------------------------------------------------------------
                                           General notes

# The on-sequence over SIO <CommunicationHead> can not include any character, which could be
  understand by modem as Hayes-Command and also any character, which could be understand
  as MagicFax-answer of its status <Device_IDLE>.
# This firmware recognize after command '?' the type of flash-firmware installed in
  the device, and so also the hardware type of the device. There are these possibilities :

     IDENTIFICATION          USED IN DEVICE   RECOGNITION OF PC    FLASH TYPE
     ------------------------------------------------------------------------
       3.3x - 3.4x           old MemoFax         ONLY RTS             --
       3.5x upto             new MemoFax         RTS/DTR           AMD 29010
       4.3x                  old SaferFax        ONLY RTS             --
       5.3x                  old SaferFax        ONLY RTS          ATMEL 29010
       5.5x upto             new SaferFax        RTS/DTR           AMD 29010

*)

Const Version              = '2.03';        (* Windows-software release                *)
      ProjectName          = 'Fax Control'; (* Name of application showed on main form *)
      NewFirmwareN_Pos1    = $31;           (* Firmware-label position in the file for *)
      NewFirmwareN_Pos2    = $32;           (* FLASH. Attn! - we read from in-record,  *)
      NewFirmwareN_Pos3    = $33;           (* with declaration [1..n], so address in  *)
      NewFirmwareL_Pos1    = $34;           (* this file <a> is at record-address[a+1]!*)

      APF_Signature_1      = 'A';
      APF_Signature_2      = 'P';
      APF_Signature_3      = 'F';
      APF_Signature_4      = '1';
      APF_Signature_5      = '0';
      APF_Signature_6      = Chr(26);
      ProgFileName         = 'CONTROL.EXE';
      ConfFileName         = 'CONTROL.CFG';
      PathArchiveFaxes     = 'SFAARCH\';
      IDFaxWorkFileName    = PathArchiveFaxes+'FAX.WRK';
      IDFaxFileName        = PathArchiveFaxes+'FAX.LST';
      FileFaxNamePrefix    = 'FX';
      FileFaxNamePathPre   = PathArchiveFaxes+FileFaxNamePrefix;
      AllNamePostfix       = '.ARC';
      FirmwareExtension    = 'FWR';

      ExtensionBMP         = 'BMP';
      ExtensionDCX         = 'DCX';
      ExtensionPCX         = 'PCX';
      ExtensionTIFF        = 'TIF';
      DefaultExportFile    = 'FAX00001';
      DefaultExportFileM   = 'EXPORT';

      Device_IDLE          = '1';

      CommunicationHead    = '$@!!_TeLeJeT_!!@';
      HintPause            = 300;

      Cr                   = Chr(13);
      Bsl                  = '\';

      InRecordTotalLen     = 254;
      OutRecordTotalLen    = 8192;
      FlashVoiceBankLen    = $10000-$200;
      FlashVoiceBlocksB0   = $80-$2;
      FlashVoiceBlocksB1   = $80;
      FlashVoiceBlocks     = $100-$2;
      FlashBankBlocks      = $80;
      MaxRepeats           = 5;
      IDLen                = 20;
      DummyLen             = 64;
      FirmwareBufferLen    = $100;
      FirmwareFileLength   = $20000;

      IDMaxLength          = 20;
      PostFixLength        = 2;
      NSetupPars           = 33;

      SaferFax             = 'S';
      MemoFax              = 'M';
      Anonymus             = 'A';

      MyResSystemNone      = 100;
      MyResSystemSetup     = 101;
      MyResSystemFirmware  = 103;
      MyResSystemQuit      = 104;

      MyResMainTranNone    = 'N';
      MyResMainTranTrans   = 'T';
      MyResMainTranTranEr  = 'R';
      MyResMainTranErase   = 'E';
      MyResMainTranQuit    = 'Q';

      MyResMainFunctNone   = 'N';
      MyResMainFunctTrans  = 'T';
      MyResMainFunctFArch  = 'F';
      MyResMainFunctSetup  = 'S';
      MyResMainFunctQuit   = 'Q';

      MyResSelFaxesNone    = 'N';
      MyResSelFaxesView    = 'V';
      MyResSelFaxesPrint   = 'P';
      MyResSelFaxesErase   = 'D';
      MyResSelFaxesExport  = 'E';
      MyResSelFaxesQuit    = 'Q';

      MyResViewFaxesNone   = 'N';
      MyResViewFaxesRefr   = 'R';
      MyResViewFaxesPrint  = 'P';
      MyResViewFaxesExport = 'E';
      MyResViewFaxesQuit   = 'Q';

      MyResExportFaxesNone = 'N';
      MyResExportFaxesTo1F = '1';
      MyResExportFaxesToNF = 'F';
      MyResExportFaxesQuit = 'Q';

      MyResPrintingNone    = 'N';
      MyResPrintingAbort   = 'A';

      MyResFileDefNone     = 'N';
      MyResFileDefOkay     = 'O';
      MyResFileDefQuit     = 'Q';

      MyResFirmWarnNone    = 100;
      MyResFirmWarnOkay    = 101;
      MyResFirmWarnBreak   = 102;

      MyResEraseFaxesNone  = 'N';
      MyResEraseFaxesOK    = 'O';
      MyResEraseFaxesAbort = 'A';

      MyResEraseInDevNone  = 'N';
      MyResEraseInDevOK    = 'O';
      MyResEraseInDevAbort = 'A';

      MyResPrinterTestNone = 'N';
      MyResPrinterTestBrk  = 'B';

      MyResAskWhenFaxNo    = 'N';
      MyResAskWhenFaxYes   = 'Y';

      MyResSetupBasicNone  = 100;
      MyResSetupBasicBreak = 101;
      MyResSetupBasicWrite = 102;
      MyResSetupBasicSetC1 = 103;
      MyResSetupBasicSetC2 = 104;
      MyResSetupBasicAsk   = 105;
      MyResSetupBasicAnsY  = 106;
      MyResSetupBasicAnsN  = 107;
      MyResSetupBasicTLas  = 108;
      MyResSetupBasicT24P  = 109;
      MyResSetupBasicSetM20= 110;

      FaxResNormal         = 'N';
      FaxResFine           = 'F';

      FlashOptionNone      = 'N';
      FlashOptionAMD       = 'A';
      FlashOptionATMEL     = 'T';

      DLE                  = $10;
      ETX                  = $03;

      Def_FaxNr            = 0;
      Def_FaxNRec          = 0;
      Def_FaxTime          = 0;
      Def_FaxIdent         = '--------------------';
      Def_FaxResol         = FaxResNormal;
      Def_FaxViewed        = False;
      Def_VoiceNr          = 0;
      Def_VoiceNRec        = 0;
      Def_VoiceTime        = 0;
      Def_VoiceListened    = False;

      Rot__0               = 0;
      Rot__90              = 1;
      Rot__180             = 2;
      Rot__270             = 3;

      NExportTags          = 80;

Type TBIRec   = Array[1..InRecordTotalLen] Of Byte;
     TBORec   = Array[1..OutRecordTotalLen] Of Byte;
     TFRec    = Record
                  FaxNr      : LongInt;
                  FaxNRec    : LongInt;
                  FaxTime    : TDateTime;
                  FaxIdent   : String[IDMaxLength];
                  FaxResol   : Char;
                  FaxViewed  : Boolean;
                  FaxFiller  : Array[1..9] Of Byte
                End;

     TIDFileFax   = File Of TFRec;

     TBinaryBuffer = Array[1..FirmwareBufferLen] Of Byte;

     TSetupString = Record
                      SString : String[64];
                      Changed : Boolean;
                      Active  : Boolean;
                    End;
     TExports = Array[1..NExportTags] Of String[128];

Var ConfFile          : Text;
    OutTransferFile   : File;
    FirmwareFile      : File;
    GreetingFile      : File;
    AnyFile           : File;

    DeviceType        : Char;
    DeviceStr         : String;
    FlashOption       : Char;
    RTSDTR            : Boolean;

    FirmwareFileName  : String;
    BinaryBuffer      : TBinaryBuffer;
    FirmwareStatus    : Boolean;
    FirmwareBPtr      : LongInt;

    IDFaxFile         : TIDFileFax;
    IDFaxWorkFile     : TIDFileFax;

    StartPath         : String;
    StartPathPtr      : Byte;

    ExportNames       : TExports;
    ExportFileForBMP  : String;
    ExportFileForDCX  : String;
    ExportFileForPCX  : String;
    ExportFileForTIFF : String;
    ExportFileNrBMP   : LongInt;
    ExportFileNrDCX   : LongInt;
    ExportFileNrPCX   : LongInt;
    ExportFileNrTIFF  : LongInt;
    FileStrNr         : String;
    NameCntr          : LongInt;
    FileNameOK        : Integer;
    RestartExport     : Boolean;
    ExportStatus      : Boolean;
    NExportFaxes      : LongInt;
    DExportFax        : LongInt; 
    NExportPages      : LongInt;
    DExportPage       : LongInt;
    ExportFaxFileName : String;
    ExportDone        : Boolean;
    ExportBreak       : Boolean;
    ExportTraceFaxIn  : String;
    ExportTraceFaxOut : String;
    NewExportNameBMP  : Boolean;
    NewExportNameDCX  : Boolean;
    NewExportNamePCX  : Boolean;
    NewExportNameTIFF : Boolean;
    FaxExportZoomX    : Integer;
    FaxExportZoomY    : Integer;
    ZoomExportXMult   : LongInt;
    ZoomExportXDiv    : LongInt;
    ZoomExportYMult   : LongInt;
    ZoomExportYDiv    : LongInt;

    InputString       : String;
    IDLineFax         : TFRec;

    InRecord          : TBIRec;
    OutRecord         : TBORec;
    InRecordPtr       : Word;
    OutRecordPtr      : Word;

    InRecordLen       : Integer;
    OutRecordLen      : Integer;

    ConfFileOkay      : Boolean;
    ComNr             : Integer;
    ComNrOkay         : Boolean;
    ComSpeed          : LongInt;
    Done              : Boolean;
    DevicePresent     : Boolean;
    DeviceConnected   : Boolean;
    DeviceReread      : Boolean;
    DeviceFailure     : Boolean;
    DeviceColdstartReq: Boolean;

    RecordPtr         : Word;

    ActStrVersion     : String;
    ActNumVersion     : Integer;
    ActLangVersion    : Char;
    NewStrVersion     : String;
    NewNumVersion     : Integer;
    NewLangVersion    : Char;

    MemBase           : Integer;
    MemExtension      : Integer;
    MemString         : String;

    NFaxes            : Integer;
    NDFiles           : Integer;
    CommandoStr       : String;
    FaxID             : String;
    FaxesErased       : Boolean;
    FaxResolution     : Char;

    A_NFaxes          : LongInt;
    A_HighestNFax     : LongInt;
    A_FaxNr           : LongInt;
    A_FaxNrDispl      : LongInt;
    A_FaxSelected     : LongInt;
    A_FaxNrPrinted    : LongInt;
    A_FaxNrSearch     : LongInt;
    A_HighestNVoice   : LongInt;
    A_FaxFileName     : String;
    IDRow             : String;
    IDRowNibble       : String;
    A_DumpName        : String;
    FaxViewerActZoom  : Byte;
    FaxActZoomText    : String;
    FaxRotateText     : String;
    ZoomXMult         : LongInt;
    ZoomXDiv          : LongInt;
    ZoomYMult         : LongInt;
    ZoomYDiv          : LongInt;
    XChangeM          : LongInt;
    XChangeD          : LongInt;
    CrHereSave        : Boolean;

    ViewerMouseStatus : Boolean;
    MoveMenuStartX    : LongInt;
    MoveMenuStartY    : LongInt;

    NRecords          : Integer;
    RecordNr          : Integer;
    FailureRepeater   : Byte;
    Timeout50ms       : Boolean;
    Timeout200ms      : Boolean;
    Timeout500ms      : Boolean;
    Timeout1000ms     : Boolean;
    Timeout2000ms     : Boolean;
    Timeout5000ms     : Boolean;
    Timeout16000ms    : Boolean;
    Timeout60000ms    : Boolean;
    DoubleTimer       : Boolean;
    Character         : Char;

    DoneSystem        : Boolean;
    DoneTransfer      : Boolean;
    DoneSetup         : Boolean;
    DoneXSetup        : Boolean;
    DoneXFirmware     : Boolean;

    UpdateAllowed     : Boolean;

    MyResMainTran     : Char;
    MyResMainFunct    : Char;
    MyResSelFaxes     : Char;
    MyResViewFaxes    : Char;
    MyResPrinting     : Char;
    MyResFileDef      : Char;
    MyResRecord       : Char;
    MyResEraseFaxes   : Char;
    MyResExportFaxes  : Char;
    MyResEraseInDev   : Char;
    MyResPrinterTest  : Char;
    MyResAskWhenFax   : Char;   
    HelpPosition      : Byte;
    BlockBreak        : Boolean;
    BreakTimer        : Boolean;
    RebootFirmware    : Boolean;

    AskPrinterSetup   : Boolean;
    FaxRotation       : Byte;

    InTransferByte    : Byte;
    OutTransferByte   : Byte;
    EndOfFile         : Boolean;
    EndOfPage         : Boolean;
    LastRecord        : Boolean;
    WriteFaxNPages    : Word;
    WriteFaxNBytes    : LongInt;
    WriteImageFlags   : Word;
    WriteDateTime     : LongInt;
    WritePos          : LongInt;
    WritePosFaxNPages : LongInt;
    WritePosPageBytes : LongInt;
    WritePosFaxOffset : LongInt;
    WriteSignature    : Array[1..6] Of Char;
    WriteFaxID        : String[IDLen];
    WriteDummy        : Array[1..DummyLen] Of Byte;
    DummyPtr          : Byte;

    AllSetupStrings   : Boolean;
    SetupPar          : Integer;
    SetupString       : String;
    SetupString_IDENT : TSetupString;
    SetupString_NRES1 : TSetupString;
    SetupString_NRES2 : TSetupString;
    SetupString_NRES3 : TSetupString;
    SetupString_NRES4 : TSetupString;
    SetupString_DIAL1 : TSetupString;
    SetupString_DIAL2 : TSetupString;
    SetupString_DIAL3 : TSetupString;
    SetupString_DIAL4 : TSetupString;
    SetupString_MDRES : TSetupString;
    SetupString_ATRX1 : TSetupString;
    SetupString_ATRX2 : TSetupString;
    SetupString_ATRX3 : TSetupString;
    SetupString_ATTX1 : TSetupString;
    SetupString_ATTX2 : TSetupString;
    SetupString_ATTX3 : TSetupString;
    SetupString_AURTS : TSetupString;
    SetupString_AUDTR : TSetupString;
    SetupString_FAXBR : TSetupString;
    SetupString_FAXBS : TSetupString;
    SetupString_NRING : TSetupString;
    SetupString_FCLAS : TSetupString;
    SetupString_PRINT : TSetupString;
    SetupString_LFD24 : TSetupString;
    SetupString_LASRG : TSetupString;
    SetupString_LASRS : TSetupString;
    SetupString_ERRES : TSetupString;
    SetupString_DIALT : TSetupString;
    SetupString_FIRM1 : TSetupString;
    SetupString_FIRM2 : TSetupString;
    SetupString_FIRM3 : TSetupString;
    SetupString_LANGU : TSetupString;
    SetupString_EETES : TSetupString;
    SetupString_ATCPI : TSetupString;
    SetupString_DUMMY : TSetupString;

    CallParam         : String;

implementation

Begin                                
  WriteSignature[1]:=APF_Signature_1;
  WriteSignature[2]:=APF_Signature_2;
  WriteSignature[3]:=APF_Signature_3;
  WriteSignature[4]:=APF_Signature_4;
  WriteSignature[5]:=APF_Signature_5;
  WriteSignature[6]:=APF_Signature_6;
  For DummyPtr:=1 To SizeOf(WriteDummy) Do
    WriteDummy[DummyPtr]:=0;
  For DummyPtr:=1 To SizeOf(IDLineFax.FaxFiller) Do
    IDLineFax.FaxFiller[DummyPtr]:=0;
  NewExportNameBMP:=True;
  NewExportNameDCX:=True;
  NewExportNamePCX:=True;
  NewExportNameTIFF:=True
end.
