unit Unitlisf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  Unitglob,
  Unitidfi,
  Unittool,
  Unitpsta,
  Unitfxer,
  Unitexpo,
  Buttons, ExtCtrls;

type
  TFormListFaxes = class(TForm)
    ListBoxFaxes: TListBox;
    SpeedButtonQuitListFaxes: TSpeedButton;
    BevelArchivStat: TBevel;
    LabelFaxesTotal: TLabel;
    LabelFaxesSelected: TLabel;
    EditFaxesTotal: TEdit;
    EditFaxesSelected: TEdit;
    HeaderFaxListe: THeader;
    BevelSelectFaxes: TBevel;
    SpeedButtonSelectAllFaxes: TSpeedButton;
    SpeedButtonUnselectAllFaxes: TSpeedButton;
    SpeedButtonSelectViewedFaxes: TSpeedButton;
    SpeedButtonSelectUnviewedFaxes: TSpeedButton;
    LabelFaxMultiSelect: TLabel;
    BevelFaxesService: TBevel;
    LabelFaxService: TLabel;
    SpeedButtonFaxesView: TSpeedButton;
    SpeedButtonFaxesPrint: TSpeedButton;
    SpeedButtonFaxesErase: TSpeedButton;
    SpeedButtonFaxesExport: TSpeedButton;
    procedure SpeedButtonQuitListFaxesClick(Sender: TObject);
    procedure SpeedButtonSelectAllFaxesClick(Sender: TObject);
    procedure SpeedButtonUnselectAllFaxesClick(Sender: TObject);
    procedure SpeedButtonSelectViewedFaxesClick(Sender: TObject);
    procedure SpeedButtonFaxesViewClick(Sender: TObject);
    procedure SpeedButtonFaxesEraseClick(Sender: TObject);
    procedure SpeedButtonFaxesPrintClick(Sender: TObject);
    procedure SpeedButtonSelectUnviewedFaxesClick(Sender: TObject);
    procedure ListBoxFaxesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBoxFaxesDblClick(Sender: TObject);
    procedure SpeedButtonFaxesExportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormListFaxes: TFormListFaxes;

Procedure BuildFaxList;
Procedure HideFaxList;
Procedure DumpFaxes;
Procedure ExportLFaxes;
Procedure EraseFaxes;
Procedure UpDateButtons;

implementation

{$R *.DFM}

Procedure BuildFaxList;
Label 1;
Var L_FaxNr : LongInt;
Begin
  PresetExportParameters;
1:
  OpenReadIDFaxFile;
  SeekAndReadLastIDFax;
  SeekFirstIDFax;
  While FormListFaxes.ListBoxFaxes.Items.Count<>0 Do
    FormListFaxes.ListBoxFaxes.Items.Delete(0);
  FormListFaxes.EditFaxesTotal.Text:=IntToStr(A_NFaxes);
  For L_FaxNr:=1 To A_NFaxes Do
    Begin
      Read(IDFaxFile,IDLineFax);
      With IDLineFax Do
        Begin
          IDRow:='';

          IDRowNibble:=IntToStr(FaxNr);
          While (Length(IDRowNibble)<7) Do
            IDRowNibble:=' '+IDRowNibble;
          IDRow:=IDRowNibble+' ';

          IDRowNibble:=DateToStr(FaxTime);
          While (Length(IDRowNibble)<11) Do
            IDRowNibble:=' '+IDRowNibble;
          IDRow:=IDRow+IDRowNibble+' ';

          IDRowNibble:=FaxIdent;
          If (Length(IDRowNibble)>IDMaxLength) Then
            IDRowNibble:=Copy(IDRowNibble,1,IDMaxLength);
          While (Length(IDRowNibble)<IDMaxLength) Do
            IDRowNibble:=' '+IDRowNibble;
          IDRow:=IDRow+IDRowNibble+' ';

          IDRowNibble:=IntToStr(FaxNRec Div 4);
          While (Length(IDRowNibble)<5) Do
            IDRowNibble:=' '+IDRowNibble;
          IDRow:=IDRow+IDRowNibble+' ';

          If FaxResol=FaxResNormal Then
            IDRow:=IDRow+' Norm '
          Else
            IDRow:=IDRow+' Fein ';

          If FaxViewed Then
            IDRow:=IDRow+'     JA   '
          Else
            IDRow:=IDRow+'          ';

          FormListFaxes.ListBoxFaxes.Items.Add(IDRow)
        End
    End;
  CloseIDFaxFile;
  MyResSelFaxes:=MyResSelFaxesNone;
  Repeat
    UpDateButtons;
    If (MyResSelFaxes=MyResSelFaxesPrint) Then
      Begin
        DumpFaxes;
        GoTo 1
      End;
    If (MyResSelFaxes=MyResSelFaxesErase) Then
      Begin
        EraseFaxes;
        MyResSelFaxes:=MyResSelFaxesNone;
        If FaxesErased Then
          GoTo 1
      End;
    If (MyResSelFaxes=MyResSelFaxesExport) Then
      Begin
        ExportLFaxes;
        MyResSelFaxes:=MyResSelFaxesNone;
        GoTo 1
      End;
    FormListFaxes.ShowModal
  Until (MyResSelFaxes=MyResSelFaxesQuit) Or
        (MyResSelFaxes=MyResSelFaxesView)
End;

Procedure HideFaxList;
Begin
  FormListFaxes.Hide
End;

Procedure DumpFaxes;
Var L_FaxNr : LongInt;
Begin
  AskPrinterSetup:=True;
  MyResPrinting:=MyResPrintingNone;
  MyResSelFaxes:=MyResSelFaxesNone;
  A_FaxNrPrinted:=0;
  For L_FaxNr:=1 To A_NFaxes Do
    If FormListFaxes.ListBoxFaxes.Selected[L_FaxNr-1] Then
      Begin
        Inc(A_FaxNrPrinted);
        OpenReadIDFaxFile;
        SeekAndReadActIDFax(L_FaxNr);
        A_FaxFileName:=BuildFileName(StartPath+FileFaxNamePathPre,
                                     IDLineFax.FaxNr,
                                     AllNamePostfix);
        A_DumpName:=BuildFileName(FileFaxNamePrefix,
                                  IDLineFax.FaxNr,
                                  AllNamePostfix);
        CloseIDFaxFile;
        PrintThisFax;
        If (MyResPrinting<>MyResPrintingNone) Then
          Exit
      End
End;

Procedure ExportLFaxes;
Var L_FaxNr : LongInt;
Begin
  NExportFaxes:=0;
  For L_FaxNr:=1 To A_NFaxes Do
    If FormListFaxes.ListBoxFaxes.Selected[L_FaxNr-1] Then
      Begin
        Inc(NExportFaxes);
        OpenReadIDFaxFile;
        SeekAndReadActIDFax(L_FaxNr);
        ExportNames[NExportFaxes]:=BuildFileName(StartPath+FileFaxNamePathPre,
                                                 IDLineFax.FaxNr,
                                                 AllNamePostfix);
        CloseIDFaxFile
      End;
  ExportFaxes
End;

Procedure EraseFaxes;
Var L_FaxNr : LongInt;
Begin
  MyResEraseFaxes:=MyResEraseFaxesNone;
  FormFaxesErase.GaugeEraseFaxes.MinValue:=0;
  FormFaxesErase.GaugeEraseFaxes.MaxValue:=A_NFaxes;
  FormFaxesErase.GaugeEraseFaxes.Progress:=0;
  FormFaxesErase.GaugeEraseFaxes.BackColor:=clSilver;
  FormFaxesErase.GaugeEraseFaxes.ForeColor:=clNavy;
  FormFaxesErase.Show;
  Repeat
    Application.ProcessMessages
  Until (MyResEraseFaxes<>MyResEraseFaxesNone);
  L_FaxNr:=0;
  If (MyResEraseFaxes=MyResEraseFaxesAbort) Then
    Begin
      FormFaxesErase.Hide;
      FaxesErased:=False;
      Exit
    End;
  OpenReadIDFaxFile;
  OpenWriteIDFaxWorkFile;
  While Not(EofIDFaxFile) Do
    Begin
      Inc(L_FaxNr);
      FormFaxesErase.GaugeEraseFaxes.Progress:=L_FaxNr;
      ReadActIDFax;
      WriteWorkActIDFax
    End;
  CloseIDFaxFile;
  EraseIDFaxFile;
  CloseIDFaxWorkFile;

  OpenReadIDFaxWorkFile;
  OpenWriteIDFaxFile;
  FormFaxesErase.GaugeEraseFaxes.BackColor:=clNavy;
  FormFaxesErase.GaugeEraseFaxes.Progress:=0;
  FormFaxesErase.GaugeEraseFaxes.ForeColor:=clRed;
  For L_FaxNr:=1 To A_NFaxes Do
    Begin
      A_FaxNr:=L_FaxNr;
      FormFaxesErase.GaugeEraseFaxes.Progress:=A_FaxNr;
      ReadWorkActIDFax;
      If Not(FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]) Then
        WriteActIDFax
      Else
        Begin
          A_FaxFileName:=BuildFileName(StartPath+FileFaxNamePathPre,
                                       IDLineFax.FaxNr,
                                       AllNamePostfix);
          EraseAnyFile(A_FaxFileName)
        End
    End;
  CloseIDFaxFile;
  CloseIDFaxWorkFile;
  EraseIDFaxWorkFile;
  FaxesErased:=True;
  FormFaxesErase.Hide
End;

Procedure UpDateButtons;
Begin
  A_FaxSelected:=FormListFaxes.ListBoxFaxes.SelCount;
  FormListFaxes.EditFaxesSelected.Text:=IntToStr(A_FaxSelected);
  If (FormListFaxes.ListBoxFaxes.SelCount>0) Then
    Begin
      FormListFaxes.SpeedButtonFaxesView.Enabled:=True;
      FormListFaxes.SpeedButtonFaxesErase.Enabled:=True;
      FormListFaxes.SpeedButtonFaxesExport.Enabled:=True;
      FormListFaxes.SpeedButtonFaxesPrint.Enabled:=True
    End
  Else
    Begin
      FormListFaxes.SpeedButtonFaxesView.Enabled:=False;
      FormListFaxes.SpeedButtonFaxesErase.Enabled:=False;
      FormListFaxes.SpeedButtonFaxesExport.Enabled:=False;
      FormListFaxes.SpeedButtonFaxesPrint.Enabled:=False
    End
End;

procedure TFormListFaxes.SpeedButtonQuitListFaxesClick(Sender: TObject);
begin
  ModalResult:=mrOK
end;

procedure TFormListFaxes.SpeedButtonSelectAllFaxesClick(Sender: TObject);
Var A_FaxNr : LongInt;
begin
  For A_FaxNr:=1 To A_NFaxes Do
    FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=True;
  UpDateButtons
end;

procedure TFormListFaxes.SpeedButtonUnselectAllFaxesClick(Sender: TObject);
Var A_FaxNr : LongInt;
begin
  For A_FaxNr:=1 To A_NFaxes Do
    FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=False;
  UpDateButtons
end;

procedure TFormListFaxes.SpeedButtonSelectUnviewedFaxesClick(
  Sender: TObject);
Var A_FaxNr : LongInt;
begin
  OpenReadIDFaxFile;
  SeekFirstIDFax;
  For A_FaxNr:=1 To A_NFaxes Do
    Begin
      Read(IDFaxFile,IDLineFax);
      If Not(IDLineFax.FaxViewed) Then
        FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=True
      Else
        FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=False
    End;
  CloseIDFaxFile;
  UpDateButtons
end;

procedure TFormListFaxes.SpeedButtonSelectViewedFaxesClick(
  Sender: TObject);
Var A_FaxNr : LongInt;
begin
  OpenReadIDFaxFile;
  SeekFirstIDFax;
  For A_FaxNr:=1 To A_NFaxes Do
    Begin
      Read(IDFaxFile,IDLineFax);
      If IDLineFax.FaxViewed Then
        FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=True
      Else
        FormListFaxes.ListBoxFaxes.Selected[A_FaxNr-1]:=False
    End;
  CloseIDFaxFile;
  UpDateButtons
end;

procedure TFormListFaxes.SpeedButtonFaxesViewClick(Sender: TObject);
begin
  MyResSelFaxes:=MyResSelFaxesView;
  ModalResult:=mrOK
end;

procedure TFormListFaxes.SpeedButtonFaxesEraseClick(Sender: TObject);
begin
  MyResSelFaxes:=MyResSelFaxesErase;
  ModalResult:=mrOK
end;

procedure TFormListFaxes.SpeedButtonFaxesPrintClick(Sender: TObject);
begin
  MyResSelFaxes:=MyResSelFaxesPrint;
  ModalResult:=mrOK
end;

procedure TFormListFaxes.ListBoxFaxesClick(Sender: TObject);
begin
  UpDateButtons
end;

procedure TFormListFaxes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If (MyResSelFaxes=MyResSelFaxesNone) Then
    MyResSelFaxes:=MyResSelFaxesQuit
end;

procedure TFormListFaxes.ListBoxFaxesDblClick(Sender: TObject);
begin
  MyResSelFaxes:=MyResSelFaxesView;
  ModalResult:=mrOK
end;

procedure TFormListFaxes.SpeedButtonFaxesExportClick(Sender: TObject);
begin
  MyResSelFaxes:=MyResSelFaxesExport;
  ModalResult:=mrOK
end;

end.
