unit Unitmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  Unitglob,
  Unitconf,
  Unitcomp,
  Unittran,
  Unittime,
  Unitfaxv,
  Unittool,
  Unitflas,
  Unithshk,
  Unitselt,
  Unitsefu,
  Unitstaw,
  Unitstar,
  Unitforp,
  Unittrys,
  Menus;

type
  TFormMain = class(TForm)
    BevelTransfer: TBevel;
    BevelFArchiv: TBevel;
    SpeedButtonTransferFV: TSpeedButton;
    SpeedButtonFArchiv: TSpeedButton;
    LabelTransfer1: TLabel;
    LabelTransfer2: TLabel;
    LabelFArchiv1: TLabel;
    LabelFArchiv2: TLabel;
    BitBtnMainQuit: TBitBtn;
    BevelSetup: TBevel;
    SpeedButtonSetup: TSpeedButton;
    LabelSystem1: TLabel;
    MainMenu: TMainMenu;
    MenuMainFile: TMenuItem;
    MenuMainWorks: TMenuItem;
    MainMenuQuit: TMenuItem;
    MenuMainTransfer: TMenuItem;
    MainMenuArchiv: TMenuItem;
    MenuMainSetup: TMenuItem;
    procedure SpeedButtonTransferFVClick(Sender: TObject);
    procedure SpeedButtonFArchivClick(Sender: TObject);
    procedure SpeedButtonSetupClick(Sender: TObject);
    procedure BitBtnMainQuitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuMainTransferClick(Sender: TObject);
    procedure MenuMainSetupClick(Sender: TObject);
    procedure MainMenuQuitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MainMenuArchivClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

Procedure MainProgramm;
Procedure EnableButtons;
Procedure SelectDevicePicturesAndTexts;

implementation

{$R *.DFM}

Procedure MainProgramm;
Label 1,2,3;
Begin

  
  FindStartingPath;

  
  FormMain.Show;
  FormMain.Cursor:=crHourGlass;
  Application.ProcessMessages;

  
  PrepareTree;

  
  ReadRowParameters;

  
  ReadConfiguration;
  If Not(ConfFileOkay) Then
    Begin
      SetConfigurationDefaults;
      WriteConfiguration
    End;

  
3:

   DevicePresent:=False;
   DeviceFailure:=False;
   DeviceConnected:=False;
   ComNrOkay:=False;

  

   OpenCommunication;
   If ComNrOkay Then
     GoTo 2;



1:

   While (Not(ComNrOkay) Or Not(DevicePresent)) Do
     Begin
       If ComNrOkay Then
         CloseCommunication;
       SetNewComPort;
       If Done Then
          Begin
            FormMain.Hide;
            Exit
          End;
       WriteConfiguration;
       GoTo 3
     End;

2:

 

  DeviceColdstartReq:=False;                                    (* FIX-[1.02] *)
  MyResMainFunct:=MyResMainFunctNone;
  FormMain.Cursor:=crDefault;
  RebootFirmware:=False;
  Repeat
    EnableButtons;
    FormMain.Show;
    Application.ProcessMessages;
    Case MyResMainFunct Of
      MyResMainFunctTrans : Begin
                              EstablishConnection;
                              SelectDevicePicturesAndTexts;
                              FormMain.Hide;
                                Begin
                                  If (Not(DevicePresent) Or
                                      DeviceFailure) Then
                                    GoTo 1;
                                  MainTransfer;
                                  If Not(DevicePresent) Then
                                    Goto 1;
                                  If DeviceReread Then
                                    DeviceReread:=False
                                  Else
                                    MyResMainFunct:=MyResMainFunctNone
                                End
                            End;
      MyResMainFunctFArch : Begin
                              FormMain.Hide;
                              FaxGlobalViewer;
                              MyResMainFunct:=MyResMainFunctNone
                            End;
      MyResMainFunctSetup : Begin
                              EstablishConnection;
                              If (Not(DevicePresent) Or
                                DeviceFailure) Then
                                GoTo 1;
                              SelectDevicePicturesAndTexts;
                              TryAskWhenFaxes;
                              If (MyResAskWhenFax=MyResAskWhenFaxYes) Then
                                Begin
                                  FormMain.Hide;
                                  SetupFunctions;
                                  If RebootFirmware Then
                                    MyResMainFunct:=MyResMainFunctQuit
                                  Else
                                    MyResMainFunct:=MyResMainFunctNone
                                End
                              Else
                                Begin
                                  MyResMainFunct:=MyResMainFunctNone
                                End
                            End
    End
  Until (MyResMainFunct=MyResMainFunctQuit);



  If DeviceColdstartReq Then
    DeviceColdStart
  Else
    DeviceWarmStart;

  CloseCommunication;
  FormMain.Hide

End;

procedure EnableButtons;
begin
  FormMain.SpeedButtonTransferFV.Enabled:=True;
  FormMain.SpeedButtonFArchiv.Enabled:=True;
  FormMain.SpeedButtonSetup.Enabled:=True;
  FormMain.BitBtnMainQuit.Enabled:=True;
  FormMain.MenuMainFile.Enabled:=True;
  FormMain.MenuMainWorks.Enabled:=True
end;

Procedure SelectDevicePicturesAndTexts;
Begin
  FormMain.SpeedButtonSetup.Glyph:=SelectDevicePicture;
  FormSelectTransfer.Image1.Picture.Bitmap:=SelectDevicePicture;
  FormReadSetup.ImageDeviceRSetup.Picture.Bitmap:=SelectDevicePicture;
  FormWriteSetup.ImageDeviceWSetup.Picture.Bitmap:=SelectDevicePicture;
  FormTran.ImageDevice.Picture.Bitmap:=SelectDevicePicture;
  FormMain.LabelSystem1.Caption:=DeviceStr+' Setup';
  FormSetupFunctions.LabelSetup1.Caption:='Setup des '+DeviceStr;
  FormSetupFunctions.Caption:=DeviceStr+' Einstellung';
  FormHandshake.Caption:='PC spricht '+DeviceStr+' an'
End;

procedure TFormMain.SpeedButtonTransferFVClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctTrans
end;

procedure TFormMain.SpeedButtonFArchivClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctFArch
end;

procedure TFormMain.SpeedButtonSetupClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctSetup
end;

procedure TFormMain.BitBtnMainQuitClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctQuit
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  FormMain.SpeedButtonTransferFV.Enabled:=False;
  FormMain.SpeedButtonFArchiv.Enabled:=False;
  FormMain.SpeedButtonSetup.Enabled:=False;
  FormMain.BitBtnMainQuit.Enabled:=False;
  FormMain.MenuMainFile.Enabled:=False;
  FormMain.MenuMainWorks.Enabled:=False;
  FormMain.Caption:=ProjectName+' Ver.'+Version
end;

procedure TFormMain.MenuMainTransferClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctTrans
end;

procedure TFormMain.MenuMainSetupClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctSetup
end;

procedure TFormMain.MainMenuQuitClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctQuit
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyResMainFunct:=MyResMainFunctQuit
end;

procedure TFormMain.MainMenuArchivClick(Sender: TObject);
begin
  MyResMainFunct:=MyResMainFunctFArch
end;

end.
