unit Unitsefu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  Unitglob,
  Unitflas,
  Unitsetb, Menus;

type
  TFormSetupFunctions = class(TForm)
    BevelSetup: TBevel;
    BevelFirmware: TBevel;
    SpeedButtonDeviceSetup: TSpeedButton;
    SpeedButtonDownloadFirmware: TSpeedButton;
    LabelSetup1: TLabel;
    LabelFirmware1: TLabel;
    LabelFirmware2: TLabel;
    BitBtnSystemEnd: TBitBtn;
    LabelROMRelease: TLabel;
    LabelACTROMRelease: TLabel;
    MenuSettings: TMainMenu;
    MenuSettingsFile: TMenuItem;
    MenuSettingsChoice: TMenuItem;
    MenuSettingsQuit: TMenuItem;
    MenuSettingsSetup: TMenuItem;
    MenuSettingsDownloadFirmware: TMenuItem;
    LabelRAMCapacity: TLabel;
    LabelACTRAMCapacity: TLabel;
    procedure BitBtnSystemEndClick(Sender: TObject);
    procedure SpeedButtonDownloadFirmwareClick(Sender: TObject);
    procedure SpeedButtonDeviceSetupClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuSettingsQuitClick(Sender: TObject);
    procedure MenuSettingsSetupClick(Sender: TObject);
    procedure MenuSettingsDownloadFirmwareClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSetupFunctions: TFormSetupFunctions;

Procedure SetupFunctions;

implementation

{$R *.DFM}

Procedure SetupFunctions;
Begin
  Repeat
    DoneSystem:=False;
    DoneXFirmware:=False;
    DoneXSetup:=False;
    FormSetupFunctions.ShowModal;
    If (FormSetupFunctions.ModalResult=MyResSystemFirmware) Then
      Begin
        DownloadAllInFlash;
        If DoneXFirmware Then
          Begin
            DoneSystem:=True;
            RebootFirmware:=True
          End
      End;
    If (FormSetupFunctions.ModalResult=MyResSystemSetup) Then
      Begin
        SetupDevice;
        If DoneXSetup Then
          Begin
            DoneSystem:=True;
            RebootFirmware:=True
          End
       End;
    If (FormSetupFunctions.ModalResult=MyResSystemQuit) Or
       DeviceFailure Then
      DoneSystem:=True
  Until DoneSystem
End;

procedure TFormSetupFunctions.BitBtnSystemEndClick(Sender: TObject);
begin
  ModalResult:=MyResSystemQuit
end;

procedure TFormSetupFunctions.SpeedButtonDownloadFirmwareClick(
  Sender: TObject);
begin
  ModalResult:=MyResSystemFirmware
end;

procedure TFormSetupFunctions.SpeedButtonDeviceSetupClick(Sender: TObject);
begin
  ModalResult:=MyResSystemSetup
end;

procedure TFormSetupFunctions.FormShow(Sender: TObject);
begin
  FormSetupFunctions.LabelACTROMRelease.Caption:=ActStrVersion;
  FormSetupFunctions.LabelACTRAMCapacity.Caption:=MemString;
  If (FlashOption<>FlashOptionNone) Then
    Begin
      FormSetupFunctions.SpeedButtonDownloadFirmware.Enabled:=True;
      FormSetupFunctions.LabelFirmware1.Font.Color:=clBlack;
      FormSetupFunctions.LabelFirmware2.Font.Color:=clBlack;
      FormSetupFunctions.MenuSettingsDownloadFirmware.Enabled:=True
    End
  Else
    Begin
      FormSetupFunctions.SpeedButtonDownloadFirmware.Enabled:=False;
      FormSetupFunctions.LabelFirmware1.Font.Color:=clGray;
      FormSetupFunctions.LabelFirmware2.Font.Color:=clGray;
      FormSetupFunctions.MenuSettingsDownloadFirmware.Enabled:=False
    End
end;

procedure TFormSetupFunctions.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If (ModalResult<>MyResSystemSetup) And
     (ModalResult<>MyResSystemFirmware) Then
    ModalResult:=MyResSystemQuit
end;

procedure TFormSetupFunctions.MenuSettingsQuitClick(Sender: TObject);
begin
  ModalResult:=MyResSystemQuit
end;

procedure TFormSetupFunctions.MenuSettingsSetupClick(Sender: TObject);
begin
  ModalResult:=MyResSystemSetup
end;

procedure TFormSetupFunctions.MenuSettingsDownloadFirmwareClick(
  Sender: TObject);
begin
  ModalResult:=MyResSystemFirmware
end;

end.
