unit UnitSelt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Unitglob,
  Unitconf,
  Unitcomp,
  Unittran,
  Unittime,
  Unitfaxv,
  Unittool,
  Unitflas,
  Unithshk,
  Unitware,
  Unitforp,
  ExtCtrls, StdCtrls, Buttons, Menus;

type
  TFormSelectTransfer = class(TForm)
    BevelContent: TBevel;
    LabelDeviceStatus: TLabel;
    LabelF: TLabel;
    EditFax: TEdit;
    BitBtnMainAbort: TBitBtn;
    BevelRemoteAction: TBevel;
    SpeedButtonTransfer: TSpeedButton;
    SpeedButtonErase: TSpeedButton;
    SpeedButtonTransferErase: TSpeedButton;
    LabelDeviceAction: TLabel;
    LabelCopy1: TLabel;
    LabelCopy2: TLabel;
    LabelErase1: TLabel;
    LabelErase2: TLabel;
    LabelCopyErase1: TLabel;
    LabelCopyErase2: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    MenuSelectTransfer: TMainMenu;
    MenuTransferFile: TMenuItem;
    MenuTransferQuit: TMenuItem;
    MenuTransferTransfer: TMenuItem;
    MenuTransferStore: TMenuItem;
    MenuTransferErase: TMenuItem;
    MenuTransferAuto: TMenuItem;
    procedure BitBtnMainAbortClick(Sender: TObject);
    procedure SpeedButtonTransferClick(Sender: TObject);
    procedure SpeedButtonEraseClick(Sender: TObject);
    procedure SpeedButtonTransferEraseClick(Sender: TObject);
    procedure MenuTransferQuitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuTransferStoreClick(Sender: TObject);
    procedure MenuTransferEraseClick(Sender: TObject);
    procedure MenuTransferAutoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSelectTransfer: TFormSelectTransfer;

Procedure MainTransfer;

implementation

{$R *.DFM}

Procedure MainTransfer;
Label 1;
Begin

  (* Aktualizace informaci ve formulari *)

  DeviceReread:=False;
  FormSelectTransfer.Show;
  FormSelectTransfer.Cursor:=crDefault;
  FormSelectTransfer.EditFax.Text:=IntToStr(NFaxes);
  If NFaxes=0 Then
    Begin
      FormSelectTransfer.EditFax.Color:=clGray;
    End
  Else
    Begin
      FormSelectTransfer.EditFax.Color:=clWhite;
    End;

 (*  Podle stavu znemoznime urcite akce - vypneme buttony *)

  If (NFaxes=0) Then
    Begin
      FormSelectTransfer.SpeedButtonTransfer.Enabled:=False;
      FormSelectTransfer.SpeedButtonErase.Enabled:=False;
      FormSelectTransfer.SpeedButtonTransferErase.Enabled:=False;
      FormSelectTransfer.MenuTransferTransfer.Enabled:=False
    End;

  (* Pockame si na prikaz - button a provedeme akci *)

  MyResMainTran:=MyResMainTranNone;
  Repeat
    Application.ProcessMessages;
    Case MyResMainTran Of
      MyResMainTranTrans : Begin
                             MyResMainTran:=MyResMainTranNone;
                             If (NFaxes>0) Then
                                Begin
                                  FormTran.Show;
                                  FormTran.GaugeRecords.MinValue:=0;
                                  FormTran.EditNFiles.Text:=IntToStr(NFaxes);
                                  NDFiles:=0;
                                  FormSelectTransfer.Cursor:=crHourGlass;
                                  FormTran.Cursor:=crHourGlass;
                                  TransferFaxes;
                                  FormSelectTransfer.Cursor:=crDefault;
                                  FormTran.Cursor:=crDefault;
                                  If DeviceFailure Then
                                    GoTo 1;
                                  FormSelectTransfer.Cursor:=crHourGlass;
                                  FormTran.Cursor:=crHourGlass;
                                  FormSelectTransfer.Cursor:=crDefault;
                                  FormTran.Cursor:=crDefault;
                                  If DeviceFailure Then
                                    GoTo 1;
                                  FormTran.Hide
                                End
                           End;
      MyResMainTranErase : Begin
                             MyResMainTran:=MyResMainTranNone;
                             AskEraseInDevice;
                             If (MyResEraseInDev=MyResEraseInDevOK) Then
                               Begin
                                 EraseFaxes;
                                 DeviceColdstartReq:=True;
                                 DeviceReread:=True;
                                 If DeviceFailure Then
                                   GoTo 1
                               End
                           End;
      MyResMainTranTranEr: Begin
                             MyResMainTran:=MyResMainTranNone;
                             If (NFaxes>0) Then
                                Begin
                                  NDFiles:=0;
                                  FormTran.Show;
                                  FormTran.GaugeRecords.MinValue:=0;
                                  FormTran.EditNFiles.Text:=IntToStr(NFaxes);
                                  FormSelectTransfer.Cursor:=crHourGlass;
                                  FormTran.Cursor:=crHourGlass;
                                  TransferFaxes;
                                  FormSelectTransfer.Cursor:=crDefault;
                                  FormTran.Cursor:=crDefault;
                                  If DeviceFailure Then
                                    GoTo 1;
                                  FormSelectTransfer.Cursor:=crHourGlass;
                                  FormTran.Cursor:=crHourGlass;
                                  FormSelectTransfer.Cursor:=crDefault;
                                  FormTran.Cursor:=crDefault;
                                  If DeviceFailure Then
                                    GoTo 1;
                                  FormTran.Hide
                                End;
                             AskEraseInDevice;
                             If (MyResEraseInDev=MyResEraseInDevOK) Then
                               Begin
                                   EraseFaxes;
                                    DeviceColdstartReq:=True;
                                 DeviceReread:=True;
                                 If DeviceFailure Then
                                   GoTo 1
                               End
                           End
    End
  Until ((MyResMainTran=MyResMainTranQuit) Or DeviceReread);

  (* Ukonceni - dle stavu vlajek vysledek (OK,busy nebo chyba) *)

1 : FormSelectTransfer.Hide

End;

procedure TFormSelectTransfer.BitBtnMainAbortClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranQuit
end;

procedure TFormSelectTransfer.SpeedButtonTransferClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranTrans
end;

procedure TFormSelectTransfer.SpeedButtonEraseClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranErase
end;

procedure TFormSelectTransfer.SpeedButtonTransferEraseClick(
  Sender: TObject);
begin
  MyResMainTran:=MyResMainTranTranEr
end;

procedure TFormSelectTransfer.MenuTransferQuitClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranQuit
end;

procedure TFormSelectTransfer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If (MyResMainTran<>MyResMainTranQuit) Then
    Action:=caNone
end;

procedure TFormSelectTransfer.MenuTransferStoreClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranTrans
end;

procedure TFormSelectTransfer.MenuTransferEraseClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranErase
end;

procedure TFormSelectTransfer.MenuTransferAutoClick(Sender: TObject);
begin
  MyResMainTran:=MyResMainTranTranEr
end;

end.
