unit Unittool;

interface

Uses SysUtils,
     Winprocs,
     Unitglob;

Procedure RemoveChar( Var S: String; C: Char );
Procedure ReadRowParameters;
Procedure BuildCommando( Var OutStr : String;
                             InChar : Char;
                             Nn     : Integer);
Function BuildFileName(  Prefix : String;
                         Number : Word;
                        Postfix : String ) : String;
Procedure CrunchFaxHead;
Procedure CrunchVoiceHead;
Procedure GetPrevZoom;
Procedure GetNextZoom;
Procedure SetNoZoom;
Procedure GetNextRotateAngle;
Procedure WarningBeep;

implementation

(* Vyjmuti vsech znaku 'C' z retezce 'S' *)

Procedure RemoveChar( Var S: String; C: Char );
Begin
  Repeat
    HelpPosition:=Pos(C,S);
    If HelpPosition>0 Then
      Delete(S,HelpPosition,1)
  Until HelpPosition=0
End;

(* Precteni a vyhodnoceni parametru na volacim radku *)

Procedure ReadRowParameters;
Begin
  If ParamCount=0 Then          
    Exit;
  CallParam:=AnsiUpperCase(ParamStr(1))
End;

(* Vytvoreni retezce FNN (NN 2 mista hex) z F(char) a NN(integer) *)

Procedure BuildCommando( Var OutStr : String;
                             InChar : Char;
                             Nn     : Integer);
Begin
  OutStr:=InChar;
  OutStr:=OutStr+IntToHex(Nn,2)
End;

(* Vytvoreni jmena souboru z PATH+PREFIX+NUMBER(6xHEX)+POSTFIX *)

Function BuildFileName(  Prefix : String;
                         Number : Word;
                        Postfix : String ) : String;
Begin
  BuildFileName:=Prefix+IntToHex(Number,6)+Postfix
End;

(* Prechroustani hlavicky faxu prijmute od zarizeni *)

Procedure CrunchFaxHead;
Begin
  FaxID:='';
  NRecords:=0;
  FaxResolution:='-';

  HelpPosition:=Pos(Bsl,InputString);
  If HelpPosition=0 Then
    Begin
      DeviceFailure:=True;
      Exit
    End;
  FaxID:=Copy(InputString,1,HelpPosition-1);
  Delete(InputString,1,HelpPosition);

  HelpPosition:=Pos(Bsl,InputString);
  If ((HelpPosition<>5) Or (Length(InputString)<>6)) Then
    Begin
      DeviceFailure:=True;
      Exit
    End;
  NRecords:=StrToInt('$'+Copy(InputString,1,4));
  FaxResolution:=InputString[6];
  If (FaxResolution<>FaxResFine) And
     (FaxResolution<>FaxResNormal) Then
    Begin
      DeviceFailure:=True;
      Exit
    End
End;

(* Prechroustani hlavicky voice prijmute od zarizeni *)

Procedure CrunchVoiceHead;
Begin
  NRecords:=0;
  If (Length(InputString)<>4) Then
    Begin
      DeviceFailure:=True;
      Exit
    End;
  NRecords:=StrToInt('$'+Copy(InputString,1,4))
End;

(*           Nase tabulka zoom:
             ==================

   ActZoom : Text :  Pomery fine:  Pomery normal:
                       X     Y       X     Y
   -------------------------------------------------------------
      0      10%     1:20   1:40    1:20   1:20
      1      20%     1:10   1:20    1:10   1:10
      2      33%     1:6    1:12    1:6    1:6
      3      50%     1:4    1:8     1:4    1:4
      4     100%     1:2    1:4     1:2    1:2     <-- standardni
      5     150%     3:4    3:8     3:4    3:4
      6     200%     1:1    1:2     1:1    1:1
      7     250%     5:4    5:8     5:4    5:4

  ===========================================================
  Pozor ! Kvuli dodrzeni isotropie je nutne pomer X prohodit
          s pomery Y pri rotaci o 90 nebo -90 stupnu.
  ===========================================================
                                                                  *)

(* Zmenseni zoom-parametru o 1 krok nasi stupnice (isotropne)*)

Procedure GetPrevZoom;
Begin
  If (IDLineFax.FaxResol=FaxResFine) Then
    Case FaxViewerActZoom Of
      0 : Begin
          End;
      1 : Begin
            FaxViewerActZoom:=0;
            FaxActZoomText:='10%';
            ZoomXMult:=1;
            ZoomXDiv:=20;
            ZoomYMult:=1;
            ZoomYDiv:=40
          End;
      2 : Begin
            FaxViewerActZoom:=1;
            FaxActZoomText:='20%';
            ZoomXMult:=1;
            ZoomXDiv:=10;
            ZoomYMult:=1;
            ZoomYDiv:=20
          End;
      3 : Begin
            FaxViewerActZoom:=2;
            FaxActZoomText:='33%';
            ZoomXMult:=1;
            ZoomXDiv:=6;
            ZoomYMult:=1;
            ZoomYDiv:=12
          End;
      4 : Begin
            FaxViewerActZoom:=3;
            FaxActZoomText:='50%';
            ZoomXMult:=1;
            ZoomXDiv:=4;
            ZoomYMult:=1;
            ZoomYDiv:=8
          End;
      5 : Begin
            FaxViewerActZoom:=4;
            FaxActZoomText:='100%';
            ZoomXMult:=1;
            ZoomXDiv:=2;
            ZoomYMult:=1;
            ZoomYDiv:=4
          End;
      6 : Begin
            FaxViewerActZoom:=5;
            FaxActZoomText:='150%';
            ZoomXMult:=3;
            ZoomXDiv:=4;
            ZoomYMult:=3;
            ZoomYDiv:=8
          End;
      7 : Begin
            FaxViewerActZoom:=6;
            FaxActZoomText:='200%';
            ZoomXMult:=1;
            ZoomXDiv:=1;
            ZoomYMult:=1;
            ZoomYDiv:=2
          End;
      8 : Begin
            FaxViewerActZoom:=7;
            FaxActZoomText:='250%';
            ZoomXMult:=5;
            ZoomXDiv:=4;
            ZoomYMult:=5;
            ZoomYDiv:=8
          End
    End;
  If (IDLineFax.FaxResol=FaxResNormal) Then
    Case FaxViewerActZoom Of
      0 : Begin
          End;
      1 : Begin
            FaxViewerActZoom:=0;
            FaxActZoomText:='10%';
            ZoomXMult:=1;
            ZoomXDiv:=20;
            ZoomYMult:=1;
            ZoomYDiv:=20
          End;
      2 : Begin
            FaxViewerActZoom:=1;
            FaxActZoomText:='20%';
            ZoomXMult:=1;
            ZoomXDiv:=10;
            ZoomYMult:=1;
            ZoomYDiv:=10
          End;
      3 : Begin
            FaxViewerActZoom:=2;
            FaxActZoomText:='33%';
            ZoomXMult:=1;
            ZoomXDiv:=6;
            ZoomYMult:=1;
            ZoomYDiv:=6
          End;
      4 : Begin
            FaxViewerActZoom:=3;
            FaxActZoomText:='50%';
            ZoomXMult:=1;
            ZoomXDiv:=4;
            ZoomYMult:=1;
            ZoomYDiv:=4
          End;
      5 : Begin
            FaxViewerActZoom:=4;
            FaxActZoomText:='100%';
            ZoomXMult:=1;
            ZoomXDiv:=2;
            ZoomYMult:=1;
            ZoomYDiv:=2
          End;
      6 : Begin
            FaxViewerActZoom:=5;
            FaxActZoomText:='150%';
            ZoomXMult:=3;
            ZoomXDiv:=4;
            ZoomYMult:=3;
            ZoomYDiv:=4
          End;
      7 : Begin
            FaxViewerActZoom:=6;
            FaxActZoomText:='200%';
            ZoomXMult:=1;
            ZoomXDiv:=1;
            ZoomYMult:=1;
            ZoomYDiv:=1
          End;
      8 : Begin
            FaxViewerActZoom:=7;
            FaxActZoomText:='250%';
            ZoomXMult:=5;
            ZoomXDiv:=4;
            ZoomYMult:=5;
            ZoomYDiv:=4
          End;
    End;
    Case FaxRotation Of
      Rot__0,Rot__180    : Begin
                           End;
      Rot__90, Rot__270  : Begin
                             XChangeM:=ZoomXMult;
                             ZoomXMult:=ZoomYMult;
                             ZoomYMult:=XChangeM;
                             XChangeD:=ZoomXDiv;
                             ZoomXDiv:=ZoomYDiv;
                             ZoomYDiv:=XChangeD
                           End
    End
End;

(* Zvetseni zoom-parametru o 1 krok nasi stupnice (isotropne) *)

Procedure GetNextZoom;
Begin
  If (IDLineFax.FaxResol=FaxResFine) Then
    Case FaxViewerActZoom Of
      0 : Begin
            FaxViewerActZoom:=1;
            FaxActZoomText:='20%';
            ZoomXMult:=1;
            ZoomXDiv:=10;
            ZoomYMult:=1;
            ZoomYDiv:=20
          End;
      1 : Begin
            FaxViewerActZoom:=2;
            FaxActZoomText:='33%';
            ZoomXMult:=1;
            ZoomXDiv:=6;
            ZoomYMult:=1;
            ZoomYDiv:=12
          End;
      2 : Begin
            FaxViewerActZoom:=3;
            FaxActZoomText:='50%';
            ZoomXMult:=1;
            ZoomXDiv:=4;
            ZoomYMult:=1;
            ZoomYDiv:=8
          End;
      3 : Begin
            FaxViewerActZoom:=4;
            FaxActZoomText:='100%';
            ZoomXMult:=1;
            ZoomXDiv:=2;
            ZoomYMult:=1;
            ZoomYDiv:=4
          End;
      4 : Begin
            FaxViewerActZoom:=5;
            FaxActZoomText:='150%';
            ZoomXMult:=3;
            ZoomXDiv:=4;
            ZoomYMult:=3;
            ZoomYDiv:=8
          End;
      5 : Begin
            FaxViewerActZoom:=6;
            FaxActZoomText:='200%';
            ZoomXMult:=1;
            ZoomXDiv:=1;
            ZoomYMult:=1;
            ZoomYDiv:=2
          End;
      6 : Begin
            FaxViewerActZoom:=7;
            FaxActZoomText:='250%';
            ZoomXMult:=5;
            ZoomXDiv:=4;
            ZoomYMult:=5;
            ZoomYDiv:=8
          End;
      7 : Begin
            FaxViewerActZoom:=8;
            FaxActZoomText:='300%';
            ZoomXMult:=3;
            ZoomXDiv:=2;
            ZoomYMult:=3;
            ZoomYDiv:=4
          End;
      8 : Begin
          End
  End;
  If (IDLineFax.FaxResol=FaxResNormal) Then
    Case FaxViewerActZoom Of
      0 : Begin
            FaxViewerActZoom:=1;
            FaxActZoomText:='20%';
            ZoomXMult:=1;
            ZoomXDiv:=10;
            ZoomYMult:=1;
            ZoomYDiv:=10
          End;
      1 : Begin
            FaxViewerActZoom:=2;
            FaxActZoomText:='33%';
            ZoomXMult:=1;
            ZoomXDiv:=6;
            ZoomYMult:=1;
            ZoomYDiv:=6
          End;
      2 : Begin
            FaxViewerActZoom:=3;
            FaxActZoomText:='50%';
            ZoomXMult:=1;
            ZoomXDiv:=4;
            ZoomYMult:=1;
            ZoomYDiv:=4
          End;
      3 : Begin
            FaxViewerActZoom:=4;
            FaxActZoomText:='100%';
            ZoomXMult:=1;
            ZoomXDiv:=2;
            ZoomYMult:=1;
            ZoomYDiv:=2
          End;
      4 : Begin
            FaxViewerActZoom:=5;
            FaxActZoomText:='150%';
            ZoomXMult:=3;
            ZoomXDiv:=4;
            ZoomYMult:=3;
            ZoomYDiv:=4
          End;
      5 : Begin
            FaxViewerActZoom:=6;
            FaxActZoomText:='200%';
            ZoomXMult:=1;
            ZoomXDiv:=1;
            ZoomYMult:=1;
            ZoomYDiv:=1
          End;
      6 : Begin
            FaxViewerActZoom:=7;
            FaxActZoomText:='250%';
            ZoomXMult:=5;
            ZoomXDiv:=4;
            ZoomYMult:=5;
            ZoomYDiv:=4
          End;
      7 : Begin
            FaxViewerActZoom:=8;
            FaxActZoomText:='300%';
            ZoomXMult:=3;
            ZoomXDiv:=2;
            ZoomYMult:=3;
            ZoomYDiv:=2
          End;
      8 : Begin
          End
  End;
  Case FaxRotation Of
    Rot__0,Rot__180    : Begin
                         End;
    Rot__90, Rot__270  : Begin
                           XChangeM:=ZoomXMult;
                           ZoomXMult:=ZoomYMult;
                           ZoomYMult:=XChangeM;
                           XChangeD:=ZoomXDiv;
                           ZoomXDiv:=ZoomYDiv;
                           ZoomYDiv:=XChangeD
                         End
  End
End;

(* Nastaveni standardu zoom - t.j. 1:1 *)

Procedure SetNoZoom;
Begin
  If (IDLineFax.FaxResol=FaxResFine) Then
    Begin
      FaxViewerActZoom:=4;
      FaxActZoomText:='100%';
      ZoomXMult:=1;
      ZoomXDiv:=2;
      ZoomYMult:=1;
      ZoomYDiv:=4
    End;
  If (IDLineFax.FaxResol=FaxResNormal) Then
    Begin
      FaxViewerActZoom:=4;
      FaxActZoomText:='100%';
      ZoomXMult:=1;
      ZoomXDiv:=2;
      ZoomYMult:=1;
      ZoomYDiv:=2
    End;
  FaxRotation:=Rot__0;
  FaxRotateText:='0'
End;

(* Procedura vraci dalsi uhel pro rotaci faxu (isotropne) *)

Procedure GetNextRotateAngle;
Begin
  Case FaxRotation Of
    Rot__0   : Begin
                 FaxRotation:=Rot__90;
                 FaxRotateText:='90'
               End;
    Rot__90  : Begin
                 FaxRotation:=Rot__180;
                 FaxRotateText:='180'
               End;
    Rot__180 : Begin
                 FaxRotation:=Rot__270;
                 FaxRotateText:='270'
               End;
    Rot__270 : Begin
                 FaxRotation:=Rot__0;
                 FaxRotateText:='0'
               End
  End;
  Case FaxRotation Of
    Rot__0,Rot__180    : Begin
                         End;
    Rot__90, Rot__270  : Begin
                           XChangeM:=ZoomXMult;
                           ZoomXMult:=ZoomYMult;
                           ZoomYMult:=XChangeM;
                           XChangeD:=ZoomXDiv;
                           ZoomXDiv:=ZoomYDiv;
                           ZoomYDiv:=XChangeD
                         End
  End
End;

(* Kratke varovne pipnuti (click) *)

Procedure WarningBeep;
Begin
  MessageBeep(0)
End;

end.
