unit Unittran;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Gauges, ExtCtrls,
  Unitglob,
  Unitcomp,
  Unittime,
  Unittool,
  Unitidfi,
  StdCtrls;

type
  TFormTran = class(TForm)
    BevelTransfer1: TBevel;
    BevelTransfer2: TBevel;
    GaugeRecords: TGauge;
    LabelTransferNFiles: TLabel;
    ImageDevice: TImage;
    ImagePC: TImage;
    ImageToRight: TImage;
    LabelTranFileName: TLabel;
    EditNFiles: TEdit;
    EditTransferFileName: TEdit;
    LabelTransferFileNr: TLabel;
    EditFileNr: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTran: TFormTran;

Procedure TransferFaxes;
Procedure OpenWriteTransferFile( FileName : String );
Procedure CloseTransferFile;
Procedure TransferFax;
Procedure MakeFaxHeader;
Procedure MakeFaxPostProc;
Procedure MakePageHeader;
Procedure MakePagePostProc;
Procedure CopyFaxPage;
Procedure GetTransferByte;
Procedure PutTransferByte;
Procedure FlushTransferRecord;
Procedure StartAndAckTransferRecord;
Procedure RepeatTransferRecord;
Procedure WaitTransferRecordHere;
Procedure ReadTransferRecord;
Procedure UpdateTransferGauge;
Procedure EraseFaxes;

implementation

{$R *.DFM}

(* Prenos faxu *)

Procedure TransferFaxes;
Var TranFile : Integer;
Begin
  For TranFile:=1 To NFaxes Do
    Begin
      Inc(NDFiles);
      FormTran.EditFileNr.Text:=IntToStr(NDFiles);
      OpenReadIDFaxFile;
      SeekAndReadLastIDFax;
      CloseIDFaxFile;
      FormTran.EditTransferFileName.Text:=BuildFileName(FileFaxNamePrefix,
                                                        A_HighestNFax+1,
                                                        AllNamePostfix);
      OpenWriteTransferFile(BuildFileName(StartPath+FileFaxNamePathPre,
                                          A_HighestNFax+1,
                                          AllNamePostfix));

      BuildCommando(CommandoStr,'F',TranFile);
      AskAndRead5s(CommandoStr);
      If DeviceFailure Then
        Exit;
      RemoveChar(InputString,Cr);
      CrunchFaxHead;
      FormTran.GaugeRecords.MaxValue:=NRecords;
      If DeviceFailure Then
        Exit;
      TransferFax;
      If DeviceFailure Then
        Exit;
      CloseTransferFile;
      OpenReadIDFaxFile;
      SeekAndReadLastIDFax;
      BuildNewIDFaxRow;
      WriteIDFaxRow;
      CloseIDFaxFile
    End
End;

(* Otevreni souboru pro ulozeni binarnich dat *)

Procedure OpenWriteTransferFile( FileName : String );
Begin
  AssignFile(OutTransferFile,FileName);
  Rewrite(OutTransferFile,1)
End;

(* Uzavreni souboru s ulozenymi binarnimi daty *)

Procedure CloseTransferFile;
Begin
  CloseFile(OutTransferFile)
End;

(* Ulozeni celeho faxu *)

Procedure TransferFax;
Begin
  MakeFaxHeader;
  InRecordPtr:=InRecordTotalLen;
  OutRecordPtr:=0;
  EndOfFile:=False;
  LastRecord:=False;
  WriteFaxNPages:=0;
  RecordNr:=0;
  StartAndAckTransferRecord;
  If DeviceFailure Then
    Exit;
  Repeat
    MakePageHeader;
    CopyFaxPage;
    If DeviceFailure Then
      Exit;
    FlushTransferRecord;
    Inc(WriteFaxNPages);
    MakePagePostProc
  Until EndOfFile Or LastRecord;
  MakeFaxPostProc
End;

(* Vytvoreni hlavy faxu pro APF-format *)

Procedure MakeFaxHeader;
Begin
  WriteDateTime:=DateTimeToFileDate(Now);
  WritePosFaxNPages:=32;
  WritePosFaxOffset:=64;
  BlockWrite(OutTransferFile,WriteSignature,6);
  BlockWrite(OutTransferFile,WriteDateTime,4);
  BlockWrite(OutTransferFile,WriteFaxID,21);
  BlockWrite(OutTransferFile,WriteDummy,1);
  BlockWrite(OutTransferFile,WriteDummy,2);
  BlockWrite(OutTransferFile,WritePosFaxOffset,4);
  BlockWrite(OutTransferFile,WriteDummy,26)
End;

(* Doplneni hlavicky faxu o dodatecne informace APF po dopsani posl.stranky *)

Procedure MakeFaxPostProc;
Begin
  WritePos:=FilePos(OutTransferFile);
  Seek(OutTransferFile,WritePosFaxNPages);
  BlockWrite(OutTransferFile,WriteFaxNPages,2);
  Seek(OutTransferFile,WritePos)
End;

(* Vytvoreni hlavy faxove stranky pro APF-format *)

Procedure MakePageHeader;
Begin
  WriteImageFlags:=0; (* DODELAT !JEP! *)
  WritePosPageBytes:=FilePos(OutTransferFile);
  BlockWrite(OutTransferFile,WriteDummy,4);
  BlockWrite(OutTransferFile,WriteImageFlags,2);
  BlockWrite(OutTransferFile,WriteDummy,10)
End;

(* Doplneni hlavicky stranky o dodatecne informace APF po dopsani stranky *)

Procedure MakePagePostProc;
Begin
  WritePos:=FilePos(OutTransferFile);
  Seek(OutTransferFile,WritePosPageBytes);
  BlockWrite(OutTransferFile,WriteFaxNBytes,4);
  Seek(OutTransferFile,WritePos)
End;

(* Ulozeni faxove stranky *)

Procedure CopyFaxPage;
Begin
  WriteFaxNBytes:=0;
  EndOfPage:=False;
  Repeat
    GetTransferByte;
    If (EndOfFile Or DeviceFailure) Then
      Exit;
    If (InTransferByte=DLE) Then
      Begin
        GetTransferByte;
        If (EndOfFile Or DeviceFailure) Then
          Exit;
        If (InTransferByte=DLE) Then
          Begin
            OutTransferByte:=DLE;
            PutTransferByte;
            Inc(WriteFaxNBytes)
          End;
        If (InTransferByte=ETX) Then
          EndOfPage:=True
      End
    Else
      Begin
        OutTransferByte:=InTransferByte;
        PutTransferByte;
        Inc(WriteFaxNBytes)
      End
  Until EndOfPage
End;

(* Predani byte ze vstupniho recordu. Ten se doplnuje ze zarizeni
   v pripade, ze je vyprazdnen *)

Procedure GetTransferByte;
Begin
  If(InRecordPtr=InRecordTotalLen) Then
    Begin
      Inc(RecordNr);
      If (RecordNr=NRecords) Then
        LastRecord:=True;
      If (RecordNr>NRecords) Then
        Begin
          EndOfFile:=True;
          Exit
        End;
      WaitTransferRecordHere;
      If DeviceFailure Then
        Exit;
      ReadTransferRecord;
      StartAndAckTransferRecord;
      UpdateTransferGauge
    End;
  Inc(InRecordPtr);
  InTransferByte:=InRecord[InRecordPtr]
End;

(* Ulozeni bytu do vystupniho recordu + event.vyprazdneni *)

Procedure PutTransferByte;
Begin
  If(OutRecordPtr=OutRecordTotalLen) Then
    FlushTransferRecord;
  Inc(OutRecordPtr);
  OutRecord[OutRecordPtr]:=OutTransferByte
End;

(* Definitivni doprazdneni vystupniho recordu *)

Procedure FlushTransferRecord;
Begin
  BlockWrite(OutTransferFile,OutRecord,OutRecordPtr);
  OutRecordPtr:=0
End;

(* Nastartovani prijmu recordu do interniho bufferu APF, soucasne
   pozitivni kvitovani dobreho prijmu posledne prijateho recordu *)

Procedure StartAndAckTransferRecord;
Begin
  With FormComp.AsyncCom Do
    Begin
      PurgeIn;
      PurgeOut
    End;
  SendChar(Cr)
End;

(* Opakovani prijmu posledne prijateho recordu do interniho bufferu APF,
   tedy negativni kvitovani chybneho prijmu posledne prijateho recordu *)

Procedure RepeatTransferRecord;
Begin
  With FormComp.AsyncCom Do
    Begin
      PurgeIn;
      PurgeOut
    End;
  SendChar('-')
End;

(* Cekani na pripravenost dat ve vstupnim bufferu APF *)

Procedure WaitTransferRecordHere;
Label 1;
Begin
  FailureRepeater:=0;
1:
  RestartTimer2000ms;
  Repeat
    Application.ProcessMessages
  Until Timeout2000ms Or (FormComp.AsyncCom.InQueCount=InRecordTotalLen);
  If Timeout2000ms Then
    Begin
      If FailureRepeater=MaxRepeats Then
        Begin
          DeviceFailure:=True;
          Exit
        End
      Else
        Begin
          Inc(FailureRepeater);
          RepeatTransferRecord;
          GoTo 1
        End
    End
End;

(* Vycteni vstupniho bufferu APF do vstupniho recordu *)

Procedure ReadTransferRecord;
Begin
  ReadRecord(InRecord,InRecordTotalLen);
  InRecordPtr:=0
End;

(* Update obrazovky - hlaseni pomoci gauge pro tento file *)

Procedure UpdateTransferGauge;
Begin
  FormTran.GaugeRecords.Progress:=RecordNr
End;

(* Smazani vsech faxu v zarizeni *)

Procedure EraseFaxes;
Begin
  AskAndRead1s('X');
  If DeviceFailure Then
    Exit;
  WaitAndRead16s
End;

procedure TFormTran.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If Not(DoneTransfer) Then
    Action:=caNone
end;

procedure TFormTran.FormShow(Sender: TObject);
begin
  DoneTransfer:=False
end;

procedure TFormTran.FormHide(Sender: TObject);
begin
  DoneTransfer:=True
end;

end.
