unit Unitidfi;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Unitglob;

type
  TFormIDfi = class(TForm)
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormIDfi: TFormIDfi;

Procedure OpenReadIDFaxFile;
Procedure OpenWriteIDFaxFile;
Procedure OpenReadIDFaxWorkFile;
Procedure OpenWriteIDFaxWorkFile;
Procedure OpenReadIDVoiceFile;
Procedure OpenWriteIDVoiceFile;
Procedure OpenReadIDVoiceWorkFile;
Procedure OpenWriteIDVoiceWorkFile;
Procedure CloseIDFaxFile;
Procedure CloseIDFaxWorkFile;
Procedure EraseIDFaxFile;
Procedure EraseIDFaxWorkFile;
Procedure CloseIDVoiceFile;
Procedure CloseIDVoiceWorkFile;
Procedure EraseIDVoiceFile;
Procedure EraseIDVoiceWorkFile;

Procedure SeekAndReadLastIDFax;
Procedure SeekFirstIDFax;
Procedure SeekAndReadActIDFax( N : LongInt );
Procedure SeekAndRewriteActIDFax( N : LongInt );
Procedure ReadActIDFax;
Procedure WriteActIDFax;
Procedure ReadWorkActIDFax;
Procedure WriteWorkActIDFax;
Function EofIDFaxFile : Boolean;

Procedure SeekAndReadLastIDVoice;
Procedure SeekFirstIDVoice;
Procedure SeekAndReadActIDVoice( N : LongInt );
Procedure SeekAndRewriteActIDVoice( N : LongInt );
Procedure ReadActIDVoice;
Procedure WriteActIDVoice;
Procedure ReadWorkActIDVoice;
Procedure WriteWorkActIDVoice;
Function EofIDVoiceFile : Boolean;

Procedure BuildNewIDFaxRow;
Procedure BuildNewIDVoiceRow;
Procedure WriteIDFaxRow;
Procedure WriteIDVoiceRow;

Procedure EraseAnyFile( FileName : String );

implementation

{$R *.DFM}



Procedure OpenReadIDFaxFile;
Begin
  AssignFile(IDFaxFile,StartPath+IDFaxFileName);
  Reset(IDFaxFile)
End;



Procedure OpenWriteIDFaxFile;
Begin
  AssignFile(IDFaxFile,StartPath+IDFaxFileName);
  Rewrite(IDFaxFile)
End;



Procedure OpenReadIDFaxWorkFile;
Begin
  AssignFile(IDFaxWorkFile,StartPath+IDFaxWorkFileName);
  Reset(IDFaxWorkFile)
End;


Procedure OpenWriteIDFaxWorkFile;
Begin
  AssignFile(IDFaxWorkFile,StartPath+IDFaxWorkFileName);
  Rewrite(IDFaxWorkFile)
End;



Procedure OpenReadIDVoiceFile;
Begin
End;


Procedure OpenWriteIDVoiceFile;
Begin
End;



Procedure OpenReadIDVoiceWorkFile;
Begin
End;



Procedure OpenWriteIDVoiceWorkFile;
Begin
End;


Procedure CloseIDFaxFile;
Begin
  CloseFile(IDFaxFile)
End;



Procedure CloseIDFaxWorkFile;
Begin
  CloseFile(IDFaxWorkFile)
End;



Procedure EraseIDFaxFile;
Begin
  Erase(IDFaxFile)
End;


Procedure EraseIDFaxWorkFile;
Begin
  Erase(IDFaxWorkFile)
End;



Procedure CloseIDVoiceFile;
Begin
End;


Procedure CloseIDVoiceWorkFile;
Begin
End;



Procedure EraseIDVoiceFile;
Begin
End;



Procedure EraseIDVoiceWorkFile;
Begin
End;



Procedure SeekAndReadLastIDFax;
Begin
  With IDLineFax Do
    Begin
      FaxNr:=Def_FaxNr;
      FaxNRec:=Def_FaxNRec;
      FaxTime:=Def_FaxTime;
      FaxIdent:=Def_FaxIdent;
      FaxResol:=Def_FaxResol;
      FaxViewed:=Def_FaxViewed
    End;
  A_NFaxes:=FileSize(IDFaxFile);
  If A_NFaxes>0 Then
    Begin
      Seek(IDFaxFile,A_NFaxes-1);
      ReadActIDFax
    End;
  A_HighestNFax:=IDLineFax.FaxNr
End;



Procedure SeekFirstIDFax;
Begin
  Seek(IDFaxFile,0)
End;



Procedure SeekAndReadActIDFax( N : LongInt );
Begin
  Seek(IDFaxFile,N-1);
  ReadActIDFax
End;



Procedure SeekAndRewriteActIDFax( N : LongInt );
Begin
  Seek(IDFaxFile,N-1);
  Write(IDFaxFile,IDLineFax)
End;

Procedure ReadActIDFax;
Begin
  Read(IDFaxFile,IDLineFax)
End;


Procedure WriteActIDFax;
Begin
  Write(IDFaxFile,IDLineFax)
End;


Procedure ReadWorkActIDFax;
Begin
  Read(IDFaxWorkFile,IDLineFax)
End;


Procedure WriteWorkActIDFax;
Begin
  Write(IDFaxWorkFile,IDLineFax)
End;


Function EofIDFaxFile : Boolean;
Begin
  EofIDFaxFile:=Eof(IDFaxFile)
End;


Procedure SeekAndReadLastIDVoice;
Begin
End;


Procedure SeekFirstIDVoice;
Begin
End;

 
Procedure SeekAndReadActIDVoice( N : LongInt );
Begin
End;


Procedure SeekAndRewriteActIDVoice( N : LongInt );
Begin
End;


Procedure ReadActIDVoice;
Begin
End;


Procedure WriteActIDVoice;
Begin
End;


Procedure ReadWorkActIDVoice;
Begin
End;

Procedure WriteWorkActIDVoice;
Begin
End;


Function EofIDVoiceFile : Boolean;
Begin
End;


Procedure BuildNewIDFaxRow;
Begin
  With IDLineFax Do
    Begin
      FaxNr:=A_HighestNFax+1;
      FaxNRec:=NRecords;
      FaxTime:=Now;
      FaxIdent:=FaxID;
      FaxResol:=FaxResolution;
      FaxViewed:=False
    End
End;


Procedure BuildNewIDVoiceRow;
Begin
    Begin
    End
End;


Procedure WriteIDFaxRow;
Begin
  Write(IDFaxFile,IDLineFax)
End;


Procedure WriteIDVoiceRow;
Begin
End;


Procedure EraseAnyFile( FileName : String );
Begin
  If FileExists(FileName) Then
    Begin
      AssignFile(AnyFile,FileName);
      Reset(AnyFile,1);
      CloseFile(AnyFile);
      Erase(AnyFile)
    End
End;

end.
